var Widgetic = (function () {
'use strict';

var commonjsGlobal = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};





function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var parse$1;

parse$1 = function(str) {
  var i, m, o, uri;
  o = parse$1.options;
  m = o.parser[(o.strictMode ? "strict" : "loose")].exec(str);
  uri = {};
  i = 14;
  while (i--) {
    uri[o.key[i]] = m[i] || "";
  }
  uri[o.q.name] = {};
  uri[o.key[12]].replace(o.q.parser, function($0, $1, $2) {
    if ($1) {
      return uri[o.q.name][$1] = $2;
    }
  });
  uri[o.h.name] = {};
  uri[o.key[13]].replace(o.h.parser, function($0, $1, $2) {
    if ($1) {
      return uri[o.h.name][$1] = $2;
    }
  });
  return uri;
};

parse$1.options = {
  strictMode: false,
  key: ["source", "protocol", "authority", "userInfo", "user", "password", "host", "port", "relative", "path", "directory", "file", "query", "hash"],
  q: {
    name: "queryKey",
    parser: /(?:^|&)([^&=]*)=?([^&]*)/g
  },
  h: {
    name: "hashKey",
    parser: /(?:^|&)([^&=]*)=?([^&]*)/g
  },
  parser: {
    strict: /^(?:([^:\/?#]+):)?(?:\/\/((?:(([^:@]*)(?::([^:@]*))?)?@)?([^:\/?#]*)(?::(\d*))?))?((((?:[^?#\/]*\/)*)([^?#]*))(?:\?([^#]*))?(?:#(.*))?)/,
    loose: /^(?:(?![^:@]+:[^:@\/]*@)([^:\/?#.]+):)?(?:\/\/)?((?:(([^:@]*)(?::([^:@]*))?)?@)?([^:\/?#]*)(?::(\d*))?)(((\/(?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[?#]|$)))*\/?)?([^?#\/]*))(?:\?([^#]*))?(?:#(.*))?)/
  }
};

var parse_1 = parse$1;

var config$1;
var domain;
var domainProtocol;
var host;
var o;
var parse;
var parsedDomain;
var protocol;
var ref;
var ref1;
var ref2;
var ref3;
var wl;

wl = window.location;

if (!wl.origin) {
  wl.origin = wl.protocol + "//" + wl.hostname + (wl.port ? ':' + wl.port : '');
}

parse = parse_1;

domain = ((ref = window.widgeticOptions) != null ? ref.domain : void 0) || 'widgetic.com';

domainProtocol = ((ref1 = window.widgeticOptions) != null ? ref1.domainProtocol : void 0) || 'https';

o = "?lo=" + (encodeURIComponent(wl.origin));

protocol = ((ref2 = window.widgeticOptions) != null ? ref2.secure : void 0) === false ? 'http' : 'https';

parsedDomain = parse(domain);

host = parsedDomain.host + (parsedDomain.port ? ':' + parsedDomain.port : '');

config$1 = {
  proxy: protocol + "://" + host + "/sdk/proxy.html" + o + "#proxy",
  popup: protocol + "://" + host + "/sdk/proxy.html" + o + "#popup",
  auth: protocol + "://" + domain + "/oauth/v2/auth",
  composition: protocol + "://" + domain + "/api/v2/compositions/{id}/embed.html" + o,
  widget: protocol + "://" + domain + "/api/v2/widgets/{id}/embed.html" + o,
  editor: protocol + "://" + domain + "/api/v2/editor.html" + o,
  plugin: protocol + "://" + host + "/plugin" + o,
  api: "/api/v2/",
  domain: domainProtocol + "://" + host,
  lo: decodeURIComponent(parse(wl).queryKey.lo || wl.origin),
  crossdomain: ((ref3 = window.widgeticOptions) != null ? ref3.crossdomain : void 0) || true
};

var config_1 = config$1;

var add;
var rem;

add = 'addEventListener';

rem = 'removeEventListener';

var event$2 = {
  on: function(el, type, fn, capture) {
    if (capture == null) {
      capture = false;
    }
    if (el[add]) {
      return el[add](type, fn, capture);
    } else {
      return el.attachEvent("on" + type, fn);
    }
  },
  off: function(el, type, fn, capture) {
    if (capture == null) {
      capture = false;
    }
    if (el[rem]) {
      return el[rem](type, fn, capture);
    } else {
      return el.detachEvent("on" + type, fn);
    }
  }
};

var uxhr$1 = createCommonjsModule(function (module, exports) {
(function (root, factory) {
	{
		module.exports = factory();
	}
}(commonjsGlobal, function () {

	"use strict";

	return function (url, data, options) {

		data = data || '';
		options = options || {};

		var complete = options.complete || function(){},
			success = options.success || function(){},
			error = options.error || function(){},
			headers = options.headers || {},
			method = options.method || 'GET',
			sync = options.sync || false,
			req = (function() {

				{

					// CORS (IE8-9)
					if (url.indexOf('http') === 0 && typeof XDomainRequest !== 'undefined') {
						return new XDomainRequest();
					}

					// local, CORS (other browsers)
					return new XMLHttpRequest();

				}

			})();

		if (!req) {
			throw new Error ('Browser doesn\'t support XHR');
		}

		// serialize data?
		if (typeof data !== 'string') {
			var serialized = [];
			for (var datum in data) {
				serialized.push(datum + '=' + data[datum]);
			}
			data = serialized.join('&');
		}

		// set timeout
		if ('ontimeout' in req) {
			req.ontimeout = +options.timeout || 0;
		}

		// listen for XHR events
		req.onload = function () {
			complete(req.responseText, req.status);
			success(req.responseText);
		};
		req.onerror = function () {
			complete(req.responseText);
			error(req.responseText, req.status);
		};

		// open connection
		req.open(method, (method === 'GET' && data ? url+'?'+data : url), !sync);

		// set headers
		for (var header in headers) {
			req.setRequestHeader(header, headers[header]);
		}

		// send it
		req.send(method !== 'GET' ? data : null);

		return req;
	};

}));
});

var config$4;
var request$1;
var uxhr;

uxhr = uxhr$1;

config$4 = config_1;

request$1 = function(params) {
  var a, complete, data, headers, message, method, settings, url;
  if (!(params.id && (a = params.a))) {
    return;
  }
  url = a.u;
  method = a.m;
  data = a.d;
  message = {
    id: params.id,
    t: 'e',
    a: {}
  };
  headers = {
    "Content-type": "application/json"
  };
  if ((method = method.toUpperCase()) === 'PUT' || method === "DELETE") {
    headers['X-HTTP-Method-Override'] = method;
    method = "POST";
  }
  complete = function(response, status) {
    message.a.t = status === 200 || status === 201 || status === 202 || status === 204 ? 't' : 'f';
    message.a.d = response;
    message = JSON.stringify(message);
    if (config$4.crossdomain) {
      return window.parent.postMessage(message, '*');
    } else {
      return window.widgeticReceiver({
        origin: window.location.origin,
        data: message
      });
    }
  };
  settings = {
    method: method,
    headers: headers,
    complete: complete
  };
  return uxhr(url, data, settings);
};

var request_1 = request$1;

var slice = [].slice;

var noabort = {};

function Queue(size) {
  this._size = size;
  this._call =
  this._error = null;
  this._tasks = [];
  this._data = [];
  this._waiting =
  this._active =
  this._ended =
  this._start = 0; // inside a synchronous task callback?
}

Queue.prototype = queue$2.prototype = {
  constructor: Queue,
  defer: function(callback) {
    if (typeof callback !== "function") { throw new Error("invalid callback"); }
    if (this._call) { throw new Error("defer after await"); }
    if (this._error != null) { return this; }
    var t = slice.call(arguments, 1);
    t.push(callback);
    ++this._waiting, this._tasks.push(t);
    poke(this);
    return this;
  },
  abort: function() {
    if (this._error == null) { abort(this, new Error("abort")); }
    return this;
  },
  await: function(callback) {
    if (typeof callback !== "function") { throw new Error("invalid callback"); }
    if (this._call) { throw new Error("multiple await"); }
    this._call = function(error, results) { callback.apply(null, [error].concat(results)); };
    maybeNotify(this);
    return this;
  },
  awaitAll: function(callback) {
    if (typeof callback !== "function") { throw new Error("invalid callback"); }
    if (this._call) { throw new Error("multiple await"); }
    this._call = callback;
    maybeNotify(this);
    return this;
  }
};

function poke(q) {
  if (!q._start) {
    try { start(q); } // let the current task complete
    catch (e) {
      if (q._tasks[q._ended + q._active - 1]) { abort(q, e); } // task errored synchronously
      else if (!q._data) { throw e; } // await callback errored synchronously
    }
  }
}

function start(q) {
  while (q._start = q._waiting && q._active < q._size) {
    var i = q._ended + q._active,
        t = q._tasks[i],
        j = t.length - 1,
        c = t[j];
    t[j] = end(q, i);
    --q._waiting, ++q._active;
    t = c.apply(null, t);
    if (!q._tasks[i]) { continue; } // task finished synchronously
    q._tasks[i] = t || noabort;
  }
}

function end(q, i) {
  return function(e, r) {
    if (!q._tasks[i]) { return; } // ignore multiple callbacks
    --q._active, ++q._ended;
    q._tasks[i] = null;
    if (q._error != null) { return; } // ignore secondary errors
    if (e != null) {
      abort(q, e);
    } else {
      q._data[i] = r;
      if (q._waiting) { poke(q); }
      else { maybeNotify(q); }
    }
  };
}

function abort(q, e) {
  var i = q._tasks.length, t;
  q._error = e; // ignore active callbacks
  q._data = undefined; // allow gc
  q._waiting = NaN; // prevent starting

  while (--i >= 0) {
    if (t = q._tasks[i]) {
      q._tasks[i] = null;
      if (t.abort) {
        try { t.abort(); }
        catch (e) { /* ignore */ }
      }
    }
  }

  q._active = NaN; // allow notification
  maybeNotify(q);
}

function maybeNotify(q) {
  if (!q._active && q._call) {
    var d = q._data;
    q._data = undefined; // allow gc
    q._call(q._error, d);
  }
}

function queue$2(concurrency) {
  if (concurrency == null) { concurrency = Infinity; }
  else if (!((concurrency = +concurrency) >= 1)) { throw new Error("invalid concurrency"); }
  return new Queue(concurrency);
}



var require$$1$1 = Object.freeze({
	queue: queue$2
});

var nextInit;
var queue$1;
var steps$1;

queue$1 = (require$$1$1).queue(1);

steps$1 = {};

nextInit = function(next) {
  return steps$1.init = next;
};

queue$1.defer(nextInit);

queue$1.steps = steps$1;

var queue_1 = queue$1;

var guid$1 = function() {
  var _p8 = function(s) {
    var p = (Math.random().toString(16) + '000000000').substr(2, 8);
    return s ? '-' + p.substr(0, 4) + '-' + p.substr(4, 4) : p;
  };
  return _p8() + _p8(true) + _p8(true) + _p8();
};




var guid$3 = Object.freeze({
	default: guid$1
});

var ayepromise = createCommonjsModule(function (module, exports) {
// UMD header
(function (root, factory) {
    if (typeof undefined === 'function' && undefined.amd) {
        undefined(factory);
    } else {
        module.exports = factory();
    }
}(commonjsGlobal, function () {
    'use strict';

    var ayepromise = {};

    /* Wrap an arbitrary number of functions and allow only one of them to be
       executed and only once */
    var once = function () {
        var wasCalled = false;

        return function wrapper(wrappedFunction) {
            return function () {
                if (wasCalled) {
                    return;
                }
                wasCalled = true;
                wrappedFunction.apply(null, arguments);
            };
        };
    };

    var getThenableIfExists = function (obj) {
        // Make sure we only access the accessor once as required by the spec
        var then = obj && obj.then;

        if (typeof obj === "object" && typeof then === "function") {
            // Bind function back to it's object (so lousy 'this' will work)
            return function() { return then.apply(obj, arguments); };
        }
    };

    var aThenHandler = function (onFulfilled, onRejected) {
        var defer = ayepromise.defer();

        var doHandlerCall = function (func, value) {
            setTimeout(function () {
                var returnValue;
                try {
                    returnValue = func(value);
                } catch (e) {
                    defer.reject(e);
                    return;
                }

                if (returnValue === defer.promise) {
                    defer.reject(new TypeError('Cannot resolve promise with itself'));
                } else {
                    defer.resolve(returnValue);
                }
            }, 1);
        };

        var callFulfilled = function (value) {
            if (onFulfilled && onFulfilled.call) {
                doHandlerCall(onFulfilled, value);
            } else {
                defer.resolve(value);
            }
        };

        var callRejected = function (value) {
            if (onRejected && onRejected.call) {
                doHandlerCall(onRejected, value);
            } else {
                defer.reject(value);
            }
        };

        return {
            promise: defer.promise,
            handle: function (state, value) {
                if (state === FULFILLED) {
                    callFulfilled(value);
                } else {
                    callRejected(value);
                }
            }
        };
    };

    // States
    var PENDING = 0,
        FULFILLED = 1,
        REJECTED = 2;

    ayepromise.defer = function () {
        var state = PENDING,
            outcome,
            thenHandlers = [];

        var doSettle = function (settledState, value) {
            state = settledState;
            // Persist for handlers registered after settling
            outcome = value;

            thenHandlers.forEach(function (then) {
                then.handle(state, outcome);
            });

            // Discard all references to handlers to be garbage collected
            thenHandlers = null;
        };

        var doFulfill = function (value) {
            doSettle(FULFILLED, value);
        };

        var doReject = function (error) {
            doSettle(REJECTED, error);
        };

        var registerThenHandler = function (onFulfilled, onRejected) {
            var thenHandler = aThenHandler(onFulfilled, onRejected);

            if (state === PENDING) {
                thenHandlers.push(thenHandler);
            } else {
                thenHandler.handle(state, outcome);
            }

            // Allow chaining of calls: something().then(...).then(...)
            return thenHandler.promise;
        };

        var safelyResolveThenable = function (thenable) {
            // Either fulfill, reject or reject with error
            var onceWrapper = once();
            try {
                thenable(
                    onceWrapper(transparentlyResolveThenablesAndSettle),
                    onceWrapper(doReject)
                );
            } catch (e) {
                onceWrapper(doReject)(e);
            }
        };

        var transparentlyResolveThenablesAndSettle = function (value) {
            var thenable;

            try {
                thenable = getThenableIfExists(value);
            } catch (e) {
                doReject(e);
                return;
            }

            if (thenable) {
                safelyResolveThenable(thenable);
            } else {
                doFulfill(value);
            }
        };

        var onceWrapper = once();
        return {
            resolve: onceWrapper(transparentlyResolveThenablesAndSettle),
            reject: onceWrapper(doReject),
            promise: {
                then: registerThenHandler,
                fail: function (onRejected) {
                    return registerThenHandler(null, onRejected);
                }
            }
        };
    };

    return ayepromise;
}));
});

var pubsub$1 = createCommonjsModule(function (module) {
/**
 * pubsub.js
 *
 * A tiny, optimized, tested, standalone and robust
 * pubsub implementation supporting different javascript environments
 *
 * @author Federico "Lox" Lucignano <http://plus.ly/federico.lox>
 *
 * @see https://github.com/federico-lox/pubsub.js
 */

/*global define, module*/
(function (context) {
	'use strict';

	/**
	 * @private
	 */
	function init() {
		//the channel subscription hash
		var channels = {},
			//help minification
			funcType = Function;

		return {
			/*
			 * @public
			 *
			 * Publish some data on a channel
			 *
			 * @param String channel The channel to publish on
			 * @param Mixed argument The data to publish, the function supports
			 * as many data parameters as needed
			 *
			 * @example Publish stuff on '/some/channel'.
			 * Anything subscribed will be called with a function
			 * signature like: function(a,b,c){ ... }
			 *
			 * PubSub.publish(
			 *		"/some/channel", "a", "b",
			 *		{total: 10, min: 1, max: 3}
			 * );
			 */
			publish: function () {
				//help minification
				var args = arguments,
					// args[0] is the channel
					subs = channels[args[0]],
					len,
					params,
					x;

				if (subs) {
					len = subs.length;
					params = (args.length > 1) ?
							Array.prototype.splice.call(args, 1) : [];

					//run the callbacks asynchronously,
					//do not block the main execution process
					setTimeout(
						function () {
							//executes callbacks in the order
							//in which they were registered
							for (x = 0; x < len; x += 1) {
								subs[x].apply(context, params);
							}

							//clear references to allow garbage collection
							subs = context = params = null;
						},
						0
					);
				}
			},

			/*
			 * @public
			 *
			 * Register a callback on a channel
			 *
			 * @param String channel The channel to subscribe to
			 * @param Function callback The event handler, any time something is
			 * published on a subscribed channel, the callback will be called
			 * with the published array as ordered arguments
			 *
			 * @return Array A handle which can be used to unsubscribe this
			 * particular subscription
			 *
			 * @example PubSub.subscribe(
			 *				"/some/channel",
			 *				function(a, b, c){ ... }
			 *			);
			 */
			subscribe: function (channel, callback) {
				if (typeof channel !== 'string') {
					throw "invalid or missing channel";
				}

				if (!(callback instanceof funcType)) {
					throw "invalid or missing callback";
				}

				if (!channels[channel]) {
					channels[channel] = [];
				}

				channels[channel].push(callback);

				return {channel: channel, callback: callback};
			},

			/*
			 * @public
			 *
			 * Disconnect a subscribed function f.
			 *
			 * @param Mixed handle The return value from a subscribe call or the
			 * name of a channel as a String
			 * @param Function callback [OPTIONAL] The event handler originaally
			 * registered, not needed if handle contains the return value
			 * of subscribe
			 *
			 * @example
			 * var handle = PubSub.subscribe("/some/channel", function(){});
			 * PubSub.unsubscribe(handle);
			 *
			 * or
			 *
			 * PubSub.unsubscribe("/some/channel", callback);
			 */
			unsubscribe: function (handle, callback) {
				if (handle.channel && handle.callback) {
					callback = handle.callback;
					handle = handle.channel;
				}

				if (typeof handle !== 'string') {
					throw "invalid or missing channel";
				}

				if (!(callback instanceof funcType)) {
					throw "invalid or missing callback";
				}

				var subs = channels[handle],
					x,
					y = (subs instanceof Array) ? subs.length : 0;

				for (x = 0; x < y; x += 1) {
					if (subs[x] === callback) {
						subs.splice(x, 1);
						break;
					}
				}
			}
		};
	}

	//UMD
	if (typeof undefined === 'function' && undefined.amd) {
		//AMD module
		undefined('pubsub', init);
	} else if ('object' === 'object' && module.exports) {
		//CommonJS module
		module.exports = init();
	} else {
		//traditional namespace
		context.PubSub = init();
	}
}(commonjsGlobal));
});

var require$$1$3 = ( guid$3 && guid$1 ) || guid$3;

var guid$4;
var link$2;
var options;
var popup$1;
var rwin;

guid$4 = require$$1$3;

rwin = window;

link$2 = {};

options = function(width, height) {
  var left, top;
  left = (screen.width - width) / 2;
  top = (screen.height - height) / 2;
  return "location=no,menubar=no,toolbar=no,scrollbars=no,status=no,resizable=no,width=" + width + ",height=" + height + ",left=" + left + ",top=" + top;
};

popup$1 = function(url, deffered) {
  var check, interval, promise, ref, win;
  promise = deffered.promise;
  if ((ref = link$2.win) != null) {
    ref.close();
  }
  link$2.win = win = rwin.open(url, "widgetic_popup_" + (guid$4()), options(500, 496));
  check = function() {
    if (!win || win.closed) {
      clearInterval(interval);
      return deffered.reject('window closed');
    }
  };
  interval = setInterval(check, 50);
  promise.then(function() {
    return win.close();
  });
  return promise;
};

var popup_1 = popup$1;

var iframe$2;
var link$3;

link$3 = {};

iframe$2 = function(url, deffered) {
  var clear, fail, parent, promise, timeout;
  promise = deffered.promise;
  iframe$2 = document.createElement('iframe');
  parent = link$3.root.el;
  parent.appendChild(iframe$2);
  fail = function() {
    return deffered.reject('Timeout error');
  };
  clear = function() {
    parent.removeChild(iframe$2);
    return clearTimeout(timeout);
  };
  timeout = setTimeout(fail, 10000);
  promise.then(clear, clear);
  iframe$2.setAttribute('src', url);
  return promise;
};

iframe$2.setRoot = function(root) {
  return link$3.root = root;
};

var iframe_1 = iframe$2;

var _get;
var app;
var auth$1;
var aye$3;
var config$5;
var doAuth;
var iframe$1;
var lastScope;
var link$1;
var popup;
var url;

config$5 = config_1;

popup = popup_1;

iframe$1 = iframe_1;

aye$3 = ayepromise;

app = {};

link$1 = {};

lastScope = [];

url = function(scope, hash) {
  if (scope == null) {
    scope = [];
  }
  if (hash == null) {
    hash = 'oauth';
  }
  return config$5.auth + "?client_id=" + app.id + "&redirect_uri=" + app.uri + "&response_type=token&scope=" + (scope.join(' ')) + "#" + hash;
};

_get = function(interactive, scope) {
  var deffered, oa;
  if (interactive == null) {
    interactive = true;
  }
  deffered = aye$3.defer();
  oa = interactive ? popup : iframe$1;
  if (scope) {
    lastScope = scope;
  }
  scope = lastScope;
  link$1.deffered = deffered;
  return {
    oa: oa,
    scope: scope,
    deffered: deffered
  };
};

doAuth = function(oa, url, deffered) {
  if (!(app.id && app.uri)) {
    deffered.reject('Widgetic must be initialized with client id and redirect uri!');
    return deffered.promise;
  }
  return oa(url, deffered);
};

auth$1 = function() {
  var deffered, oa, ref, scope;
  ref = _get.apply(null, arguments), oa = ref.oa, scope = ref.scope, deffered = ref.deffered;
  return doAuth(oa, url(scope), deffered);
};

auth$1.register = function(scope) {
  var deffered, oa, ref;
  ref = _get(true, scope), oa = ref.oa, scope = ref.scope, deffered = ref.deffered;
  return doAuth(oa, url(scope, 'signup'), deffered);
};

auth$1.setAuthOptions = function(id, uri, root) {
  app.id = id;
  return app.uri = uri;
};

auth$1.getClientId = function() {
  return app.id;
};

auth$1.retry = function(response) {
  return auth$1.apply(this, response.d);
};

auth$1.connect = function(response) {
  var api, data;
  api = api_1;
  data = response.d;
  if (data && data.access_token) {
    api.setTokens(data);
    link$1.deffered.resolve(api.getStatus());
    return setTimeout(auth$1.bind(this, false), data.expires_in * 1000 - 1500);
  } else {
    return link$1.deffered.reject(api.getStatus());
  }
};

var auth_1 = auth$1;

var api$2;
var aye$2;
var config$3;
var defs;
var guid;
var link;
var prepare_message;
var pubsub;
var queue;
var request;
var requestToken;
var tknDelay;
var tokenDef;

config$3 = config_1;

request = request_1;

queue = queue_1;

guid = require$$1$3;

aye$2 = ayepromise;

pubsub = pubsub$1;

defs = {};

link = {};

tokenDef = null;

tknDelay = null;

prepare_message = function(url, method, data, id) {
  var access_token, ref;
  url = config$3.api + url;
  access_token = ((ref = link.tokens) != null ? ref.access_token : void 0) || false;
  if ((method || (method = 'GET')) instanceof Object) {
    data = method;
    method = 'GET';
  }
  if (method !== 'GET') {
    url = url + (access_token ? "?access_token=" + access_token : '');
  } else {
    data || (data = {});
    if (access_token) {
      data.access_token = access_token;
    }
  }
  return JSON.stringify({
    t: "a",
    id: id,
    a: {
      u: url,
      m: method,
      d: data
    }
  });
};

api$2 = function(url, method, data) {
  var advance, deffered, id, message, promise;
  id = guid();
  promise = (defs[id] = deffered = aye$2.defer()).promise;
  message = prepare_message.apply(this, deffered.margs = [url, method, data, id]);
  advance = function() {
    return defs[id] = null;
  };
  promise.then(advance, advance);
  link.proxy(message);
  return promise;
};

api$2.response = function(message) {
  var a, data, deffered, e, ok, ref;
  deffered = defs[message.id];
  a = message.a;
  data = a.d;
  if (data !== "") {
    try {
      data = JSON.parse(data);
    } catch (error) {
      deffered.reject(new Error("JSON Parse error!"));
      return;
    }
  }
  if (a.t === 't') {
    return deffered.resolve(data);
  } else {
    if (link.tokens && data.error && ((ref = data.error) === 'invalid_grant' || ref === 'access_denied')) {
      ok = function() {
        tokenDef = null;
        return link.proxy(prepare_message.apply(this, deffered.margs));
      };
      return requestToken().then(ok, (function() {
        tokenDef = null;
        return deffered.reject(new Error('Unable to login again!'));
      }));
    } else {
      e = new Error(data.error_description || data.message || 'Unknown Error');
      e.errors = data.errors;
      e.code = data.code;
      return deffered.reject(e);
    }
  }
};

requestToken = function() {
  var auth, message, promise;
  if ((auth = auth_1).getClientId() != null) {
    return auth(false);
  }
  promise = (tokenDef = aye$2.defer()).promise;
  message = JSON.stringify({
    t: 'r',
    d: [false]
  });
  window.parent.postMessage(message, config$3.lo);
  tknDelay = setTimeout(tokenDef.reject, 3000);
  return promise;
};

api$2.setProxy = function(proxy) {
  return link.proxy = proxy;
};

api$2.setTokens = function(tokens) {
  link.tokens = tokens;
  return pubsub.publish('api/token/update');
};

api$2.getStatus = function() {
  var ref;
  if ((ref = link.tokens) != null ? ref.access_token : void 0) {
    return {
      status: 'connected',
      accessToken: link.tokens.access_token,
      refreshToken: link.tokens.refresh_token,
      expiresIn: link.tokens.expires_in,
      scope: link.tokens.scope
    };
  } else {
    return {
      status: 'disconnected'
    };
  }
};

api$2.accessToken = function(token) {
  var ref;
  if (token) {
    clearTimeout(tknDelay);
    if (tokenDef != null) {
      tokenDef.resolve(token);
    }
    api$2.setTokens({
      access_token: token,
      refresh_token: void 0,
      expires_in: void 0,
      scope: void 0
    });
  }
  return (ref = link.tokens) != null ? ref.access_token : void 0;
};

api$2.disconnect = function() {
  pubsub.publish('api/token/update');
  return link.tokens = null;
};

api$2.queue = queue;

api$2.request = request;

var api_1 = api$2;

var Root$1;
var api$1;
var aye$1;
var config$2;
var css;
var iframe;
var proxyCreated;
var steps;

css = "#widgetic-root{position:absolute;top:-1000px;left:-1000px;width:0px;height:0px;visibility:hidden;z-index:-1} #widgetic-root iframe{width:0px;height:0px} iframe.widgetic-composition {border: none;width: 100%;height: 100%;vertical-align: middle;} iframe.widgetic-editor {width: 490px; height: 565px; border:none;overflow:hidden} .wdgtc-wrap{overflow: hidden}";

config$2 = config_1;

api$1 = api_1;

iframe = iframe_1;

steps = api$1.queue.steps;

aye$1 = ayepromise;

Root$1 = function() {
  var body;
  body = document.getElementsByTagName('body')[0];
  body.appendChild(this.el = document.createElement('div'));
  this.el.id = "widgetic-root";
  iframe.setRoot(this);
  return this;
};

proxyCreated = aye$1.defer();

Root$1.prototype.createProxy = function() {
  var fail, proxy, timeout;
  if (steps.init) {
    if (config$2.crossdomain) {
      proxy = document.createElement('iframe');
      this.el.appendChild(proxy);
      fail = function() {
        Root$1._done = null;
        clearTimeout(timeout);
        return proxyCreated.reject(new Error('Could not initialize cross-domain messaging iframe'));
      };
      timeout = setTimeout(fail, 10000);
      Root$1._done = function() {
        api$1.setProxy(function(message) {
          return proxy.contentWindow.postMessage(message, config$2.domain);
        });
        clearTimeout(timeout);
        steps.init();
        Root$1._done = steps.init = null;
        return proxyCreated.resolve();
      };
      proxy.setAttribute('src', config$2.proxy);
    } else {
      api$1.setProxy(function(message) {
        return window.widgeticReceiver({
          origin: window.location.origin,
          data: message
        });
      });
      steps.init();
      Root$1._done = steps.init = null;
      proxyCreated.resolve();
    }
  }
  return proxyCreated.promise;
};

Root$1.connect = function() {
  return typeof Root$1._done === "function" ? Root$1._done() : void 0;
};

Root$1.style = function() {
  var head, style;
  head = document.getElementsByTagName('head')[0];
  head.appendChild(style = document.createElement('style'));
  return style.textContent = css;
};

var root = Root$1;

var config$6;
var detect$1;
var parse$2;
var win$1;

config$6 = config_1;

parse$2 = parse_1;

win$1 = window;

detect$1 = function(url) {
  var data, hash, hashKey, isOauth, isPopup, isProxy, parsed, query, queryKey, sourceOrigin, type;
  if (win$1.parent && win$1.parent === win$1 && !win$1.opener) {
    return;
  }
  parsed = parse$2(url);
  hash = parsed.hash;
  hashKey = parsed.hashKey;
  queryKey = parsed.queryKey;
  isProxy = hash === 'proxy';
  isPopup = hashKey.hasOwnProperty('popup');
  isOauth = hashKey.hasOwnProperty('oauth') || hashKey.access_token;
  if (!(isOauth || isProxy || isPopup)) {
    return;
  }
  if (isOauth) {
    type = 'o';
  }
  if (isProxy) {
    type = 'i';
  }
  if (isPopup) {
    type = 'p';
  }
  data = hash ? hashKey : queryKey;
  sourceOrigin = !isOauth ? config$6.lo : win$1.location.origin;
  return (win$1.opener || win$1.parent).postMessage(JSON.stringify({
    d: data,
    t: type
  }), sourceOrigin);
};

detect$1.parse = parse$2;

var detect_1 = detect$1;

var ready;

ready = function(fn) {
  var ref;
  if ((ref = document.readyState) === 'interactive' || ref === 'complete') {
    fn();
    return;
  }
  return document.addEventListener('DOMContentLoaded', fn);
};

var ready_1 = ready;

var Composition$1;
var api$3;
var auth$2;
var comps;
var config$7;
var fn;
var guid$5;
var messageType;
var method;
var methods;
var publicApiCallDeferreds;
var queue$3;
var relayedEvents;
var indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) { return i; } } return -1; };
var slice$1 = [].slice;

config$7 = config_1;

guid$5 = require$$1$3;

queue$3 = (require$$1$1).queue;

api$3 = api_1;

auth$2 = auth_1;

comps = {};

publicApiCallDeferreds = {};

relayedEvents = ['click', 'dblclick', 'mousedown', 'mousemove', 'mouseup', 'mouseenter', 'mouseleave', 'mouseover', 'mouseout', 'wheel', 'keydown', 'keyup', 'keypress'];

Composition$1 = function(holder, opt1, opt2) {
  var client_id, composition, has_token, item, j, len, loads, options, query, ref, token, url;
  if (opt2 == null) {
    opt2 = {};
  }
  if (typeof opt1 === 'string') {
    composition = opt1;
  }
  options = composition ? opt2 : opt1;
  if (composition == null) {
    composition = options.composition;
  }
  this._initQueue();
  this._callbacks = {};
  this.publicMethods = [];
  this.publicEvents = [];
  if (composition) {
    url = config$7.composition.replace('{id}', composition);
  } else {
    url = config$7.widget.replace('{id}', options.widget_id || options.widgetid);
  }
  if (options.skin) {
    this.changeSkin(options.skin);
    if (options.skin.id) {
      url += "&theme=" + options.skin.id;
    }
  }
  if (options.content) {
    ref = options.content;
    for (j = 0, len = ref.length; j < len; j++) {
      item = ref[j];
      this.addContent(item);
    }
  }
  url += "&demo=" + options.demo;
  query = [];
  client_id = auth$2.getClientId();
  has_token = api$3.getStatus().status === 'connected';
  if (token = options.token || api$3.accessToken()) {
    query.push('access_token=' + token);
  }
  if (client_id) {
    query.push('client_id=' + client_id);
  }
  if (options.wait_editor_init) {
    query.push('wait');
  }
  if (options.branding) {
    query.push('branding=' + options.branding);
  }
  if (options.brand_pos) {
    query.push('bp=' + options.brand_pos);
  }
  if (options.edit_mode) {
    query.push('edit_mode');
  }
  if (options.resize) {
    query.push('resize=' + options.resize);
  }
  if (options.autoscale) {
    query.push('autoscale=' + options.autoscale);
  }
  if (options.adaptive) {
    query.push('adaptive=' + options.adaptive);
  }
  if (query.length) {
    url = url.replace(/(\?)|((.)(\#)|($))/, "?" + (query.length ? query.join('&') : void 0) + "&$2");
  }
  this.id = guid$5();
  comps[this.id] = this;
  this._iframe = document.createElement('iframe');
  this._iframe.setAttribute('class', 'widgetic-composition');
  this._iframe.setAttribute('name', this.id);
  this._iframe.setAttribute('allowfullscreen', true);
  this._iframe.setAttribute('scrolling', 'no');
  if (holder) {
    holder.appendChild(this._iframe);
  }
  loads = 0;
  this._iframe.addEventListener('load', (function(_this) {
    return function() {
      if (++loads === 1) {
        return;
      }
      _this._initQueue();
      return _this._trigger('reload');
    };
  })(this));
  this._iframe.setAttribute('src', url);
  if (this._iframe.parentElement && this._iframe.parentElement.parentElement.className.indexOf('wdgtc-wrap') === 0) {
    this._responsiveWrapper = this._iframe.parentElement.parentElement;
  }
  this._autoscale = options.autoscale !== 'off';
  this.api = new Proxy({}, {
    get: (function(_this) {
      return function(target, method) {
        return function() {
          var args, id;
          args = Array.from(arguments);
          id = guid$5();
          return new Promise(function(resolve, reject) {
            publicApiCallDeferreds[id] = {
              resolve: resolve,
              reject: reject
            };
            return _this.ready.then(function() {
              return _this._sendMessage({
                t: 'pa',
                d: {
                  id: id,
                  method: method,
                  args: args
                }
              });
            });
          });
        };
      };
    })(this)
  });
  return this;
};

Composition$1.prototype._initQueue = function() {
  this._queue = queue$3(1);
  this._queue.defer((function(_this) {
    return function(next) {
      return _this._startQueue = next;
    };
  })(this));
  this._readyDeferred = Widgetic.Aye.defer();
  return this.ready = this._readyDeferred.promise;
};

Composition$1.prototype.updateSize = function(width, height) {
  if (this._autoscale === 'on') {
    return;
  }
  if (width) {
    this._iframe.setAttribute('width', width);
  }
  if (height) {
    height = parseInt(height, 10);
    if (this._responsiveWrapper) {
      this._responsiveWrapper.style.height = height + 'px';
      this._responsiveWrapper.querySelector('.wdgtc-holder').style['padding-top'] = 0;
    }
    return this._iframe.style.height = height + 'px';
  }
};

Composition$1.prototype.close = function() {
  comps[this.id] = null;
  this._iframe.parentNode.removeChild(this._iframe);
  this.off();
  return this;
};

Composition$1.prototype.queue = function(callback) {
  return this._queue.defer((function(_this) {
    return function(next) {
      callback();
      return next();
    };
  })(this));
};

Composition$1.prototype._apiReady = function() {
  return this._startQueue();
};

Composition$1.prototype._ready = function() {
  return this._readyDeferred.resolve();
};

Composition$1.prototype._sendMessage = function(message) {
  this._queue.defer((function(_this) {
    return function(next) {
      _this._iframe.contentWindow.postMessage(JSON.stringify(message), '*');
      return next();
    };
  })(this));
  return this;
};

Composition$1.prototype.on = function(ev, callback) {
  var calls, evs, j, len, name;
  if (indexOf.call(relayedEvents, ev) >= 0) {
    this._sendMessage({
      t: 're',
      d: ev
    });
  }
  evs = ev.split(' ');
  calls = this.hasOwnProperty('_callbacks') && this._callbacks;
  for (j = 0, len = evs.length; j < len; j++) {
    name = evs[j];
    calls[name] || (calls[name] = []);
    calls[name].push(callback);
  }
  return this;
};

Composition$1.prototype.off = function(ev, callback) {
  var cb, evs, i, j, k, len, len1, list, name, ref;
  if (arguments.length === 0) {
    this._callbacks = {};
    return this;
  }
  if (!ev) {
    return this;
  }
  evs = ev.split(' ');
  for (j = 0, len = evs.length; j < len; j++) {
    name = evs[j];
    list = (ref = this._callbacks) != null ? ref[name] : void 0;
    if (!list) {
      continue;
    }
    if (!callback) {
      delete this._callbacks[name];
      continue;
    }
    for (i = k = 0, len1 = list.length; k < len1; i = ++k) {
      cb = list[i];
      if (!(cb === callback)) {
        continue;
      }
      list = list.slice();
      list.splice(i, 1);
      this._callbacks[name] = list;
      break;
    }
  }
  return this;
};

Composition$1.prototype._trigger = function() {
  var args;
  args = 1 <= arguments.length ? slice$1.call(arguments, 0) : [];
  setTimeout((function(_this) {
    return function() {
      var callback, ev, j, len, list, ref, results;
      ev = args.shift();
      if (ev === Composition$1.RELAY) {
        ev = args[0].type;
      }
      list = _this.hasOwnProperty('_callbacks') && ((ref = _this._callbacks) != null ? ref[ev] : void 0);
      if (!list) {
        return;
      }
      results = [];
      for (j = 0, len = list.length; j < len; j++) {
        callback = list[j];
        if (callback.apply(_this, args) === false) {
          break;
        } else {
          results.push(void 0);
        }
      }
      return results;
    };
  })(this));
  return true;
};

methods = {
  'clearContent': 'cx',
  'setContent': 'sc',
  'addContent': 'ac',
  'changeContent': 'cc',
  'removeContent': 'rc',
  'setSkin': 'ss',
  'changeSkin': 'cs',
  'addSheet': 'asht',
  'addCss': 'acss'
};

fn = function(method, messageType) {
  return Composition$1.prototype[method] = function(data) {
    return this._sendMessage({
      t: messageType,
      d: data
    });
  };
};
for (method in methods) {
  messageType = methods[method];
  fn(method, messageType);
}

Composition$1.apiReady = function(id) {
  var ref;
  return (ref = comps[id.d]) != null ? ref._apiReady() : void 0;
};

Composition$1.connect = function(id) {
  var ref;
  return (ref = comps[id.d]) != null ? ref._ready() : void 0;
};

Composition$1.event = function(data) {
  return comps[data.id]._trigger(data.e, data.d);
};

Composition$1.updateSize = function(data) {
  return comps[data.id].updateSize(data.d.width, data.d.height);
};

Composition$1.pausePlayingEmbed = function(data) {
  var currPlKey, currPlayingId, newPlayingId;
  newPlayingId = data.id;
  currPlKey = 'currentPlayingWidgeticEmbedId';
  currPlayingId = localStorage[currPlKey];
  if (currPlayingId && currPlayingId !== newPlayingId && comps[currPlayingId]) {
    comps[currPlayingId].api.pause();
  }
  return localStorage[currPlKey] = newPlayingId;
};

Composition$1.publicMethodsAndEvents = function(data) {
  comps[data.id].publicMethods = data.d.publicMethods;
  return comps[data.id].publicEvents = data.d.publicEvents;
};

Composition$1.publicApiCallReply = function(data) {
  var d, e, err, id;
  id = data.id, d = data.d, err = data.err;
  if (err) {
    e = new Error(err.message);
    e.stack = err.stack;
    publicApiCallDeferreds[id].reject(e);
  } else {
    publicApiCallDeferreds[id].resolve(d);
  }
  return delete publicApiCallDeferreds[id];
};

Composition$1.RELAY = 'r';

Composition$1.EMBED_MODE = 1;

Composition$1.EDIT_MODE = 2;

var composition = Composition$1;

var Editor$1;
var api$4;
var config$8;
var editors;
var guid$6;
var pubsub$3;
var queue$4;
var relayedEvents$1;
var indexOf$1 = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) { return i; } } return -1; };
var slice$2 = [].slice;

config$8 = config_1;

queue$4 = (require$$1$1).queue;

pubsub$3 = pubsub$1;

guid$6 = require$$1$3;

api$4 = api_1;

editors = {};

relayedEvents$1 = ['click', 'dblclick', 'mousedown', 'mousemove', 'mouseup', 'mouseenter', 'mouseleave', 'mouseover', 'mouseout', 'wheel', 'keydown', 'keyup', 'keypress'];

Editor$1 = function(holder, composition, opts) {
  var url;
  this.composition = composition;
  this._queue = queue$4(1);
  this._queue.defer((function(_this) {
    return function(next) {
      return _this._startQueue = next;
    };
  })(this));
  this._callbacks = {};
  pubsub$3.subscribe('api/token/update', this._updateToken.bind(this));
  this._updateToken();
  if (opts) {
    this.setEditorOptions(opts);
  }
  this.composition.ready.then(this._compReady.bind(this));
  editors[this.composition.id] = this;
  url = config$8.editor + '#' + this.composition.id;
  if (opts != null ? opts.asPopup : void 0) {
    if (this.frame = holder) {
      this.frame.location.href = url;
    } else {
      this.frame = window.open(url, guid$6(), "height=" + (opts.h || 565) + ",width=" + (opts.w || 490));
    }
  } else {
    this._iframe = document.createElement('iframe');
    this._iframe.setAttribute('class', 'widgetic-editor');
    this._iframe.setAttribute('name', guid$6());
    holder.appendChild(this._iframe);
    this._iframe.setAttribute('src', url);
    this.frame = this._iframe.contentWindow;
  }
  return this;
};

Editor$1.prototype.close = function() {
  editors[this.composition.id] = null;
  if (this._iframe) {
    this._iframe.parentNode.removeChild(this._iframe);
  } else {
    this.frame.close();
  }
  return this;
};

Editor$1.prototype.goTo = function(step) {
  this._sendMessage({
    t: 'step',
    d: step
  });
  return this;
};

Editor$1.prototype.setEditorOptions = function(options) {
  this.options = options != null ? options : this.options;
  this._sendMessage({
    t: 'opts',
    d: this.options
  });
  return this;
};

Editor$1.prototype.addContent = function(content) {
  this._sendMessage({
    t: 'cont',
    d: content
  });
  return this;
};

Editor$1.prototype.save = function() {
  this.goTo('done');
  return this;
};

Editor$1.prototype.on = function(ev, callback) {
  var calls, evs, j, len, name;
  if (indexOf$1.call(relayedEvents$1, ev) >= 0) {
    this._sendMessage({
      t: 'ree',
      d: ev
    });
  }
  evs = ev.split(' ');
  calls = this.hasOwnProperty('_callbacks') && this._callbacks;
  for (j = 0, len = evs.length; j < len; j++) {
    name = evs[j];
    calls[name] || (calls[name] = []);
    calls[name].push(callback);
  }
  return this;
};

Editor$1.prototype.off = function(ev, callback) {
  var cb, evs, i, j, k, len, len1, list, name, ref;
  if (arguments.length === 0) {
    this._callbacks = {};
    return this;
  }
  if (!ev) {
    return this;
  }
  evs = ev.split(' ');
  for (j = 0, len = evs.length; j < len; j++) {
    name = evs[j];
    list = (ref = this._callbacks) != null ? ref[name] : void 0;
    if (!list) {
      continue;
    }
    if (!callback) {
      delete this._callbacks[name];
      continue;
    }
    for (i = k = 0, len1 = list.length; k < len1; i = ++k) {
      cb = list[i];
      if (!(cb === callback)) {
        continue;
      }
      list = list.slice();
      list.splice(i, 1);
      this._callbacks[name] = list;
      break;
    }
  }
  return this;
};

Editor$1.prototype._trigger = function() {
  var args, callback, ev, j, len, list, ref;
  args = 1 <= arguments.length ? slice$2.call(arguments, 0) : [];
  ev = args.shift();
  if (ev === Editor$1.RELAY) {
    ev = args[0].type;
  }
  list = this.hasOwnProperty('_callbacks') && ((ref = this._callbacks) != null ? ref[ev] : void 0);
  if (!list) {
    return;
  }
  for (j = 0, len = list.length; j < len; j++) {
    callback = list[j];
    if (callback.apply(this, args) === false) {
      break;
    }
  }
  return true;
};

Editor$1.prototype._sendMessage = function(message) {
  return this._queue.defer((function(_this) {
    return function(next) {
      _this.frame.postMessage(JSON.stringify(message), '*');
      return next();
    };
  })(this));
};

Editor$1.prototype._ready = function() {
  this.ready = true;
  return this._startQueue();
};

Editor$1.prototype._compReady = function() {
  this.compReady = true;
  return this._sendMessage({
    t: 'ready'
  });
};

Editor$1.prototype._updateToken = function() {
  return this._sendMessage({
    t: 'token',
    d: api$4.accessToken()
  });
};

Editor$1.prototype._onConnect = function() {
  if (this.ready && this.compReady) {
    this._queue.defer((function(_this) {
      return function(next) {
        _this.setEditorOptions();
        _this._compReady();
        return next();
      };
    })(this));
  }
  return this._ready();
};

Editor$1.connect = function(data) {
  return editors[data.id]._onConnect();
};

Editor$1.event = function(data) {
  return editors[data.id]._trigger(data.e, data.d);
};

Editor$1.RELAY = 'er';

var editor = Editor$1;

var Plugin;
var api$5;
var config$9;
var guid$7;
var pubsub$4;
var queue$5;
var slice$3 = [].slice;

config$9 = config_1;

queue$5 = (require$$1$1).queue;

pubsub$4 = pubsub$1;

guid$7 = require$$1$3;

api$5 = api_1;

Plugin = (function() {
  Plugin.instances = {};

  Plugin.connect = function(data) {
    var instance;
    instance = Plugin.instances[data.id];
    instance._updateToken();
    instance._ready();
    return instance._sendMessage({
      t: 'ready'
    });
  };

  Plugin.event = function(data) {
    return Plugin.instances[data.id]._trigger(data.e, data.d);
  };

  Plugin.create = function(opts) {
    var instance;
    if (opts == null) {
      opts = {};
    }
    instance = new this(opts);
    return this.instances[instance.id] = instance;
  };

  function Plugin(opts) {
    var ref, url;
    this.id = guid$7();
    this.name = opts.name || this.id;
    this._queue = queue$5(1);
    this._queue.defer((function(_this) {
      return function(next) {
        return _this._startQueue = next;
      };
    })(this));
    pubsub$4.subscribe('api/token/update', this._updateToken.bind(this));
    this._updateToken();
    if (opts) {
      this.setOptions(opts);
    }
    url = config$9.plugin;
    if (this.frame = ((ref = opts.holder) != null ? ref.document : void 0) || opts.holder) {
      this._iframe = document.createElement('iframe');
      this._iframe.setAttribute('class', 'wdtc-plugin');
      this._iframe.setAttribute('name', this.name);
      this.frame.appendChild(this._iframe);
      this._iframe.setAttribute('src', url);
      this.frame = this._iframe.contentWindow;
    } else {
      this.frame = window.open(url, this.name, "height=" + (opts.h || 760) + ",width=" + (opts.w || 1270));
    }
  }

  Plugin.prototype.close = function() {
    this.constructor.instances[this.id] = null;
    delete this.constructor.instances[this.id];
    if (this._iframe) {
      this._iframe.parentNode.removeChild(this._iframe);
    } else {
      this.frame.close();
    }
    return this;
  };

  Plugin.prototype.setOptions = function(options) {
    this.options = options != null ? options : this.options;
    this._sendMessage({
      t: 'opts',
      d: this.options
    });
    return this;
  };

  Plugin.prototype.addEditorContent = function(d) {
    this._sendMessage({
      t: 'econt',
      d: d
    });
    return this;
  };

  Plugin.prototype.on = function(ev, callback) {
    var calls, evs, j, len, name;
    evs = ev.split(' ');
    calls = this.hasOwnProperty('_callbacks') && (this._callbacks || (this._callbacks = {}));
    for (j = 0, len = evs.length; j < len; j++) {
      name = evs[j];
      calls[name] || (calls[name] = []);
      calls[name].push(callback);
    }
    return this;
  };

  Plugin.prototype.off = function(ev, callback) {
    var cb, evs, i, j, k, len, len1, list, name, ref;
    if (arguments.length === 0) {
      this._callbacks = {};
      return this;
    }
    if (!ev) {
      return this;
    }
    evs = ev.split(' ');
    for (j = 0, len = evs.length; j < len; j++) {
      name = evs[j];
      list = (ref = this._callbacks) != null ? ref[name] : void 0;
      if (!list) {
        continue;
      }
      if (!callback) {
        delete this._callbacks[name];
        continue;
      }
      for (i = k = 0, len1 = list.length; k < len1; i = ++k) {
        cb = list[i];
        if (!(cb === callback)) {
          continue;
        }
        list = list.slice();
        list.splice(i, 1);
        this._callbacks[name] = list;
        break;
      }
    }
    return this;
  };

  Plugin.prototype._trigger = function() {
    var args, callback, ev, j, len, list, ref;
    args = 1 <= arguments.length ? slice$3.call(arguments, 0) : [];
    ev = args.shift();
    list = this.hasOwnProperty('_callbacks') && ((ref = this._callbacks) != null ? ref[ev] : void 0);
    if (!list) {
      return;
    }
    for (j = 0, len = list.length; j < len; j++) {
      callback = list[j];
      if (callback.apply(this, args) === false) {
        break;
      }
    }
    return true;
  };

  Plugin.prototype._sendMessage = function(message) {
    return this._queue.defer((function(_this) {
      return function(next) {
        _this.frame.postMessage(JSON.stringify(message), '*');
        return next();
      };
    })(this));
  };

  Plugin.prototype._ready = function() {
    return this._startQueue();
  };

  Plugin.prototype._updateToken = function() {
    return this._sendMessage({
      t: 'token',
      d: api$5.accessToken()
    });
  };

  return Plugin;

})();

var plugin$1 = Plugin;

var Popup;
var _getInfo;
var ackMessage;
var aye$6;
var clientRectToObject;
var config$10;
var debounce;
var defs$1;
var event$4;
var extend;
var getOffset;
var getTextFromStyleElement;
var guid$8;
var loadSheet;
var loadSheets;
var newMessage;
var replyMessage;
var send;
var ucfirst;
var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

aye$6 = ayepromise;

guid$8 = require$$1$3;

event$4 = event$2;

config$10 = config_1;

extend = function(out) {
  var arguments$1 = arguments;

  var arg, i, key, len;
  if (out == null) {
    out = {};
  }
  for (i = 0, len = arguments.length; i < len; i++) {
    arg = arguments$1[i];
    if (!arg) {
      continue;
    }
    for (key in arg) {
      if (arg.hasOwnProperty(key)) {
        out[key] = arg[key];
      }
    }
  }
  return out;
};

debounce = function(fn, t) {
  var _delay;
  if (t == null) {
    t = 10;
  }
  _delay = null;
  return function() {
    clearTimeout(_delay);
    return _delay = setTimeout(fn, t);
  };
};

getOffset = function(el) {
  var rect;
  rect = el.getBoundingClientRect();
  return {
    top: rect.top + window.scrollY,
    left: rect.left + window.scrollX
  };
};

loadSheet = function(url, el, callback) {
  var link;
  link = this.document.createElement('link');
  link.setAttribute('rel', 'stylesheet');
  link.setAttribute('type', 'text/css');
  link.setAttribute('charset', 'utf-8');
  link.setAttribute('href', url);
  if (callback) {
    event$4.on(link, 'load', callback);
    event$4.on(link, 'error', callback);
  }
  return el.appendChild(link);
};

loadSheets = function(el, sheets, optional, callback) {
  var allSheets, i, len, loadedSheets, onLoad, sheet, total, waiting;
  if (sheets == null) {
    sheets = [];
  }
  if (optional == null) {
    optional = [];
  }
  allSheets = [].concat(sheets, optional);
  total = allSheets.length;
  loadedSheets = 0;
  waiting = true;
  onLoad = (function(_this) {
    return function(ev) {
      if (ev.type === 'load' || optional.indexOf(ev.target.href) > -1) {
        ++loadedSheets;
      } else {
        console.log(new Error("Popup stylesheet \"" + ev.target.href + "\" did not load!"));
      }
      if (loadedSheets === total || !waiting) {
        return callback();
      }
    };
  })(this);
  for (i = 0, len = allSheets.length; i < len; i++) {
    sheet = allSheets[i];
    loadSheet.call(this, sheet, el, onLoad);
  }
  setTimeout(callback, 5000);
  return setTimeout((function() {
    return waiting = false;
  }), 5000);
};

defs$1 = {};

newMessage = function(data) {
  var deffered, defid, message, promise;
  defid = guid$8();
  promise = (defs$1[defid] = deffered = aye$6.defer()).promise;
  message = {
    id: defid,
    t: 'p',
    d: data
  };
  return {
    promise: promise,
    message: message
  };
};

ackMessage = function(message, data) {
  return defs$1[message.id].resolve(data);
};

send = function(message, target) {
  if (target == null) {
    target = window.parent;
  }
  if (typeof target === 'string') {
    target = window.frames[target];
  }
  return target.postMessage(JSON.stringify(message), '*');
};

replyMessage = function(message, event, response) {
  message.d.original = message.d.event;
  message.d.event = 'done';
  message.d.response = response;
  return send(message, event.source);
};

ucfirst = function(string) {
  return string.charAt(0).toUpperCase() + string.slice(1);
};

getTextFromStyleElement = function(el) {
  try {
    return el.innerHTML;
  } catch (error) {
    return el.styleSheet.cssText;
  }
};

clientRectToObject = function(rect) {
  if (!rect) {
    return {};
  }
  return {
    top: rect.top,
    right: rect.right,
    bottom: rect.bottom,
    left: rect.left,
    width: rect.width,
    height: rect.height
  };
};

_getInfo = function(popupIframe) {
  var ref;
  return {
    popup: clientRectToObject(popupIframe.getBoundingClientRect()),
    widget: clientRectToObject((ref = popupIframe._parentFrame) != null ? ref.getBoundingClientRect() : void 0)
  };
};

Popup = (function() {
  Popup.styles = {
    popup: 'body { display:inline-block; margin:0; width:auto !important; height:auto !important; overflow:hidden; background:transparent !important } #loader { width: 250px; height: 250px; border: 1px solid #d5d5d5; background: white; } .sk-three-bounce { margin: 115px auto; width: 40px; text-align: center; } .sk-three-bounce .sk-child { width: 10px; height: 10px; background-color: #262424; border-radius: 100%; display: inline-block; -webkit-animation: sk-three-bounce 1.4s ease-in-out 0s infinite both; animation: sk-three-bounce 1.4s ease-in-out 0s infinite both; } .sk-three-bounce .sk-bounce1 { -webkit-animation-delay: -0.32s; animation-delay: -0.32s; } .sk-three-bounce .sk-bounce2 { -webkit-animation-delay: -0.16s; animation-delay: -0.16s; } @-webkit-keyframes sk-three-bounce { 0%, 80%, 100% { -webkit-transform: scale(0); transform: scale(0); } 40% { -webkit-transform: scale(1); transform: scale(1); } } @keyframes sk-three-bounce { 0%, 80%, 100% { -webkit-transform: scale(0); transform: scale(0); } 40% { -webkit-transform: scale(1); transform: scale(1); } }',
    overlay: 'html, body { width:100%; height:100%; } body { display:block; margin:0; overflow:hidden; }'
  };

  Popup.popups = {};

  Popup.callbacks = {};

  Popup.iframes = {};

  Popup["new"] = function(options) {
    var name;
    if (options == null) {
      options = {};
    }
    name = options.name || guid$8();
    options.name = name;
    this.popups[name] = new Popup(options);
    return this.popups[name].init();
  };

  Popup.receiver = function(message, event) {
    var method;
    method = message.d.event;
    method = 'on' + ucfirst(method);
    return typeof Popup[method] === "function" ? Popup[method](message, event) : void 0;
  };

  Popup.onCreate = function(message, ev) {
    var iframe, name;
    name = message.d.name;
    iframe = document.createElement('iframe');
    iframe.setAttribute('class', 'wdgtc-popup');
    iframe.setAttribute('name', name);
    iframe.isOverlay = message.d.type === 'overlay';
    iframe.setAttribute('style', 'border: 0; width: 0; height: 0; position: absolute; top: 0; left: -10000px; z-index: 2147483646;');
    if (iframe.isOverlay) {
      iframe.style.zIndex = 2147483647;
    }
    iframe.isVisible = false;
    iframe._parent = ev.source;
    iframe._parentFrame = document.getElementsByName(message.d.source)[0];
    document.querySelectorAll('body')[0].appendChild(iframe);
    iframe.setAttribute('src', config$10.popup + '&name=' + encodeURIComponent(name) + '&event=ready');
    this.iframes[name] = iframe;
    iframe.doPosition = (function(_this) {
      return function() {
        var msg;
        _this.doPosition(iframe, null);
        msg = {
          t: 'p',
          d: {
            event: 'reposition',
            name: name,
            response: {
              info: _getInfo(iframe)
            }
          }
        };
        return send(msg, iframe._parent);
      };
    })(this);
    iframe.doPosition = debounce(iframe.doPosition);
    event$4.on(window, 'resize', iframe.doPosition);
    event$4.on(window, 'scroll', iframe.doPosition);
    return this.callbacks[name] = (function(_this) {
      return function() {
        delete _this.callbacks[name];
        return replyMessage(message, ev);
      };
    })(this);
  };

  Popup.onReady = function(message) {
    var base, name1;
    return typeof (base = this.callbacks)[name1 = message.d.name] === "function" ? base[name1]() : void 0;
  };

  Popup.onDone = function(message, event) {
    var method;
    method = message.d.original;
    method = 'on' + ucfirst(method) + 'Done';
    if (this[method]) {
      return this[method](message, event);
    }
    return ackMessage(message, message.d.response);
  };

  Popup.onCreateDone = function(message, event) {
    var popupFrame, source;
    source = event.source;
    if (!(popupFrame = source.frames[message.d.name])) {
      while (source !== event.source.top) {
        source = source.parent;
        try {
          if (popupFrame = source.frames[message.d.name]) {
            break;
          }
        } catch (error) {}
      }
    }
    return ackMessage(message, popupFrame);
  };

  Popup.onReposition = function(message, event) {
    this.popups[message.d.name].info = message.d.response.info;
    return this.popups[message.d.name].trigger('reposition');
  };

  Popup.onManage = function(message, event) {
    var iframe, method, name, response;
    name = message.d.name;
    iframe = this.iframes[name];
    method = 'do' + ucfirst(message.d["do"]);
    response = (typeof this[method] === "function" ? this[method](iframe, message.d) : void 0) || {};
    response.info = _getInfo(iframe);
    return replyMessage(message, event, response);
  };

  Popup.doResize = function(iframe, options) {
    if (iframe.isOverlay) {
      return options.dimensions;
    }
    iframe.style.width = options.dimensions.width + 'px';
    iframe.style.height = options.dimensions.height + 'px';
    if (options.dimensions.shadow) {
      iframe.style.boxShadow = options.dimensions.shadow;
    }
    if (options.dimensions.borderRadius) {
      iframe.style.borderRadius = options.dimensions.borderRadius;
    }
    return options.dimensions;
  };

  Popup.doHide = function(iframe, options) {
    iframe.isVisible = false;
    iframe.style.display = 'none';
  };

  Popup.doShow = function(iframe, options) {
    iframe.isVisible = true;
    iframe.style.display = 'block';
    iframe.style.position = iframe.isOverlay ? 'fixed' : 'absolute';
  };

  Popup.doPosition = function(iframe, options) {
    var anchor, frame, left, offset, popup, ref, top;
    if (!iframe.isVisible) {
      iframe.style.display = "none";
    }
    if (iframe.isOverlay) {
      iframe.style.position = 'fixed';
      iframe.style.width = '100%';
      iframe.style.height = '100%';
      iframe.style.top = 0;
      iframe.style.left = 0;
      iframe.style.bottom = 0;
      iframe.style.right = 0;
      return;
    }
    if (options) {
      iframe.positionOptions = options;
    } else {
      if (!iframe.positionOptions) {
        return;
      }
      options = iframe.positionOptions;
    }
    offset = options.offset;
    popup = options.dimensions;
    anchor = extend({}, options.anchor);
    frame = document.querySelector("iframe[name=\"" + anchor.parent + "\"]");
    if (frame) {
      ref = getOffset(frame), top = ref.top, left = ref.left;
      anchor.top += top;
      anchor.left += left;
    }
    left = window.innerWidth + window.scrollX - (anchor.left + popup.width + offset.rightMargin + offset.leftOffset);
    left = Math.max(0, anchor.left + offset.leftOffset + Math.min(0, left));
    top = window.innerHeight + window.scrollY - (anchor.top + anchor.height + popup.height + offset.bottomMargin);
    top = top >= 0 ? anchor.top + anchor.height + offset.topOffset : anchor.top - popup.height - offset.bottomMargin;
    if (top < 0) {
      top = anchor.top + anchor.height + offset.topOffset;
    }
    iframe.style.top = top + 'px';
    iframe.style.left = left + 'px';
  };

  Popup.doRelease = function(iframe, options) {
    var name;
    iframe.parentNode.removeChild(iframe);
    event$4.off(window, 'resize', iframe.doPosition);
    event$4.off(window, 'scroll', iframe.doPosition);
    name = options.name;
    delete this.iframes[name];
  };

  Popup.hideAll = function() {
    var id, iframe, iframes;
    iframes = (function() {
      var ref, results;
      ref = Popup.iframes;
      results = [];
      for (id in ref) {
        iframe = ref[id];
        results.push(iframe);
      }
      return results;
    })();
    return iframes.filter(function(iframe) {
      return iframe.isVisible;
    }).map(function(iframe) {
      Popup.doHide(iframe);
      return send({
        t: 'p',
        d: {
          event: 'hide',
          name: iframe.name
        }
      }, iframe._parent);
    });
  };

  Popup.onHide = function(message, event) {
    var popup;
    popup = this.popups[message.d.name];
    return popup._hide();
  };

  Popup.prototype.type = 'popup';

  Popup.prototype.topOffset = 0;

  Popup.prototype.leftOffset = 0;

  Popup.prototype.rightMargin = 15;

  Popup.prototype.bottomMargin = 15;

  Popup.prototype.copyStyles = true;

  function Popup(options) {
    this._prepare = bind(this._prepare, this);
    this._saveInfo = bind(this._saveInfo, this);
    this.position = bind(this.position, this);
    this._hide = bind(this._hide, this);
    this.resize = bind(this.resize, this);
    var key, ref, value;
    this.options = options;
    ref = this.options;
    for (key in ref) {
      value = ref[key];
      this[key] = value;
    }
    if (this.anchor == null) {
      this.anchor = document.body;
    }
    if (this.anchor.jquery) {
      this.anchor = this.anchor[0];
    }
    this.dimensions = {
      width: 0,
      height: 0
    };
    this.info = {};
    this.visible = false;
    this._callbacks = {};
  }

  Popup.prototype.on = function(ev, callback) {
    this._callbacks[ev] = this._callbacks[ev] || [];
    return this._callbacks[ev].push(callback);
  };

  Popup.prototype.off = function(ev) {
    if (ev) {
      return this._callbacks[ev] = [];
    }
    return this._callbacks = {};
  };

  Popup.prototype.trigger = function(ev, data) {
    var callback, i, len, ref, results;
    if (!this._callbacks[ev]) {
      return;
    }
    ref = this._callbacks[ev];
    results = [];
    for (i = 0, len = ref.length; i < len; i++) {
      callback = ref[i];
      results.push(callback(data));
    }
    return results;
  };

  Popup.prototype.init = function() {
    var promise;
    promise = this._sendEvent('create', {
      type: this.type,
      source: window.name
    });
    return promise.then(this._prepare);
  };

  Popup.prototype.append = function(el) {
    if (el.jquery) {
      el = el[0];
    }
    this.content.innerHTML = '';
    this.content.appendChild(el);
    return this.resize();
  };

  Popup.prototype.style = function(text, preserve) {
    var deferred;
    if (preserve == null) {
      preserve = false;
    }
    if (!this.styleElement) {
      this.styleElement = document.createElement('style');
      this.head.appendChild(this.styleElement);
    }
    if (this.preservedStyles == null) {
      this.preservedStyles = '';
    }
    try {
      this.styleElement.innerHTML = this.preservedStyles + text;
    } catch (error) {
      this.styleElement.styleSheet.cssText = this.preservedStyles + text;
    }
    if (preserve) {
      this.preservedStyles += text;
    }
    deferred = aye$6.defer();
    deferred.resolve(this.preservedStyles + text);
    return deferred.promise;
  };

  Popup.prototype.resize = function() {
    this.dimensions = {
      width: this.document.body.offsetWidth,
      height: this.document.body.offsetHeight
    };
    return this._sendEvent('manage', {
      "do": 'resize',
      dimensions: this.dimensions
    }).then(this._saveInfo);
  };

  Popup.prototype.hide = function() {
    return this._sendEvent('manage', {
      "do": 'hide'
    }).then(this._saveInfo).then(this._hide);
  };

  Popup.prototype._hide = function() {
    return this.visible = false;
  };

  Popup.prototype.show = function() {
    return this.position().then((function(_this) {
      return function() {
        return _this._sendEvent('manage', {
          "do": 'show'
        });
      };
    })(this)).then(this._saveInfo).then((function(_this) {
      return function() {
        return _this.visible = true;
      };
    })(this));
  };

  Popup.prototype.position = function() {
    var anchor, offset;
    offset = {
      topOffset: this.topOffset,
      leftOffset: this.leftOffset,
      bottomMargin: this.bottomMargin,
      rightMargin: this.rightMargin
    };
    anchor = getOffset(this.anchor);
    anchor.parent = window.name;
    anchor.width = parseInt(this.anchor.offsetWidth, 10);
    anchor.height = parseInt(this.anchor.offsetHeight, 10);
    return this._sendEvent('manage', {
      "do": 'position',
      anchor: anchor,
      dimensions: this.dimensions,
      offset: offset
    }).then(this._saveInfo);
  };

  Popup.prototype.release = function() {
    var deferred, promise;
    deferred = aye$6.defer();
    promise = deferred.promise;
    this.document.location.reload();
    setTimeout(deferred.resolve, 1000);
    return promise.then((function(_this) {
      return function() {
        return _this._sendEvent('manage', {
          "do": 'release'
        });
      };
    })(this));
  };

  Popup.prototype._saveInfo = function(response) {
    this.info = response.info;
    return response;
  };

  Popup.prototype._sendEvent = function(event, extra) {
    var data, message, promise, ref;
    data = {
      name: this.name,
      event: event
    };
    data = extend(data, extra);
    ref = newMessage(data), promise = ref.promise, message = ref.message;
    send(message, this.targetWindow);
    return promise;
  };

  Popup.prototype._prepare = function(window1) {
    var sheets, styles;
    this.window = window1;
    this.document = this.window.document;
    this.head = this.document.head;
    this.loader = document.createElement('div');
    this.loader.id = 'loader';
    this.loader.style.display = 'none';
    this.loader.innerHTML = '<div class="sk-three-bounce"> <div class="sk-child sk-bounce1"></div> <div class="sk-child sk-bounce2"></div> <div class="sk-child sk-bounce3"></div> </div>';
    this.document.body.appendChild(this.loader);
    this.content = document.createElement('div');
    this.document.body.appendChild(this.content);
    styles = '<style type="text/css">' + Popup.styles[this.type] + '</style>';
    this.head.insertAdjacentHTML('beforeend', styles);
    styles = document.querySelectorAll('[data-widget-style=true]');
    styles = Array.prototype.map.call(styles, getTextFromStyleElement);
    styles = styles.reduce((function(previous, current) {
      return previous += current;
    }), '');
    this.style(styles, true);
    sheets = document.querySelectorAll('link[rel="stylesheet"]');
    sheets = Array.prototype.map.call(sheets, (function(_this) {
      return function(el) {
        return el.href;
      };
    })(this));
    if (this.css || sheets.length) {
      this.loader.style.display = 'block';
      this.content.style.display = 'none';
      loadSheets.call(this, this.head, this.css, sheets, (function(_this) {
        return function() {
          _this.loader.style.display = 'none';
          _this.content.style.display = 'block';
          return _this.resize().then(function() {
            return _this.position();
          }).then(function() {
            return _this;
          });
        };
      })(this));
    }
    return this;
  };

  return Popup;

})();

event$4.on(window.document, 'click', Popup.hideAll);

var popup$3 = Popup;

'use strict';

function preserveCamelCase(str) {
	var isLastCharLower = false;
	var isLastCharUpper = false;
	var isLastLastCharUpper = false;

	for (var i = 0; i < str.length; i++) {
		var c = str[i];

		if (isLastCharLower && /[a-zA-Z]/.test(c) && c.toUpperCase() === c) {
			str = str.substr(0, i) + '-' + str.substr(i);
			isLastCharLower = false;
			isLastLastCharUpper = isLastCharUpper;
			isLastCharUpper = true;
			i++;
		} else if (isLastCharUpper && isLastLastCharUpper && /[a-zA-Z]/.test(c) && c.toLowerCase() === c) {
			str = str.substr(0, i - 1) + '-' + str.substr(i - 1);
			isLastLastCharUpper = isLastCharUpper;
			isLastCharUpper = false;
			isLastCharLower = true;
		} else {
			isLastCharLower = c.toLowerCase() === c;
			isLastLastCharUpper = isLastCharUpper;
			isLastCharUpper = c.toUpperCase() === c;
		}
	}

	return str;
}

var camelcase = function (str) {
	if (arguments.length > 1) {
		str = Array.from(arguments)
			.map(function (x) { return x.trim(); })
			.filter(function (x) { return x.length; })
			.join('-');
	} else {
		str = str.trim();
	}

	if (str.length === 0) {
		return '';
	}

	if (str.length === 1) {
		return str.toLowerCase();
	}

	if (/^[a-z0-9]+$/.test(str)) {
		return str;
	}

	var hasUpperCase = str !== str.toLowerCase();

	if (hasUpperCase) {
		str = preserveCamelCase(str);
	}

	return str
		.replace(/^[_.\- ]+/, '')
		.toLowerCase()
		.replace(/[_.\- ]+(\w|$)/g, function (m, p1) { return p1.toUpperCase(); });
};

function noop() {}

function assign(tar, src) {
	for (var k in src) { tar[k] = src[k]; }
	return tar;
}

function appendNode(node, target) {
	target.appendChild(node);
}

function insertNode(node, target, anchor) {
	target.insertBefore(node, anchor);
}

function detachNode(node) {
	node.parentNode.removeChild(node);
}

function createElement(name) {
	return document.createElement(name);
}

function blankObject() {
	return Object.create(null);
}

function destroy(detach) {
	this.destroy = noop;
	this.fire('destroy');
	this.set = this.get = noop;

	if (detach !== false) { this._fragment.u(); }
	this._fragment.d();
	this._fragment = this._state = null;
}

function _differs(a, b) {
	return a != a ? b == b : a !== b || ((a && typeof a === 'object') || typeof a === 'function');
}

function fire(eventName, data) {
	var handlers =
		eventName in this._handlers && this._handlers[eventName].slice();
	if (!handlers) { return; }

	for (var i = 0; i < handlers.length; i += 1) {
		var handler = handlers[i];

		if (!handler.__calling) {
			handler.__calling = true;
			handler.call(this, data);
			handler.__calling = false;
		}
	}
}

function get(key) {
	return key ? this._state[key] : this._state;
}

function init(component, options) {
	component._handlers = blankObject();
	component._bind = options._bind;

	component.options = options;
	component.root = options.root || component;
	component.store = component.root.store || options.store;
}

function observe(key, callback, options) {
	var fn = callback.bind(this);

	if (!options || options.init !== false) {
		fn(this.get()[key], undefined);
	}

	return this.on(options && options.defer ? 'update' : 'state', function(event) {
		if (event.changed[key]) { fn(event.current[key], event.previous && event.previous[key]); }
	});
}

function on(eventName, handler) {
	if (eventName === 'teardown') { return this.on('destroy', handler); }

	var handlers = this._handlers[eventName] || (this._handlers[eventName] = []);
	handlers.push(handler);

	return {
		cancel: function() {
			var index = handlers.indexOf(handler);
			if (~index) { handlers.splice(index, 1); }
		}
	};
}

function set(newState) {
	this._set(assign({}, newState));
	if (this.root._lock) { return; }
	this.root._lock = true;
	callAll(this.root._beforecreate);
	callAll(this.root._oncreate);
	callAll(this.root._aftercreate);
	this.root._lock = false;
}

function _set(newState) {
	var oldState = this._state,
		changed = {},
		dirty = false;

	for (var key in newState) {
		if (this._differs(newState[key], oldState[key])) { changed[key] = dirty = true; }
	}
	if (!dirty) { return; }

	this._state = assign(assign({}, oldState), newState);
	this._recompute(changed, this._state);
	if (this._bind) { this._bind(changed, this._state); }

	if (this._fragment) {
		this.fire("state", { changed: changed, current: this._state, previous: oldState });
		this._fragment.p(changed, this._state);
		this.fire("update", { changed: changed, current: this._state, previous: oldState });
	}
}

function callAll(fns) {
	while (fns && fns.length) { fns.shift()(); }
}

function _mount(target, anchor) {
	this._fragment[this._fragment.i ? 'i' : 'm'](target, anchor || null);
}

function _unmount() {
	if (this._fragment) { this._fragment.u(); }
}

var proto = {
	destroy: destroy,
	get: get,
	fire: fire,
	observe: observe,
	on: on,
	set: set,
	teardown: destroy,
	_recompute: noop,
	_set: _set,
	_mount: _mount,
	_unmount: _unmount,
	_differs: _differs
};

var embeds = {};

function add$1(ref, instance) {
  embeds[ref] = instance;
}

function remove(ref) {
  delete embeds[ref];
}

function find(ref) {
  if (ref == null) { return embeds; }
  if (!embeds[ref]) { throw new Error(("Embed " + ref + " does not exist.")); }
  return embeds[ref];
}


var embeds$1 = Object.freeze({
	add: add$1,
	remove: remove,
	find: find
});

var alignStyles = {
  left: '',
  center: 'margin: 0 auto',
  right: 'margin: 0 0 0 auto',
};

var styles = {
  fixed: function (width, height, align) {
    return {
      wrapStyle: ((alignStyles[align]) + ";max-width: " + (width.value) + (width.unit) + "; min-width: " + (width.value) + (width.unit) + ";"),
      holdStyle: ("height: " + (height.value) + (height.unit) + "; padding-top: 0;"),
    };
  },
  'allow-scale-down': function (width, height, align) {
    var ratio = height.value * 100 / width.value;
    return {
      wrapStyle: ((alignStyles[align]) + ";max-width: " + (width.value) + (width.unit) + ";"),
      holdStyle: ("padding-top: " + ratio + "%;"),
    };
  },
  'fixed-height': function (width, height, align) {
    return {
      wrapStyle: ((alignStyles[align]) + ";"),
      holdStyle: ("height: " + (height.value) + (height.unit) + "; padding-top: 0;"),
    };
  },
  'fill-width': function (width, height, align) {
    var ratio = height.value * 100 / width.value;
    return {
      wrapStyle: ((alignStyles[align]) + ";"),
      holdStyle: ("padding-top: " + ratio + "%;"),
    };
  },
  fill: function (width, height, align) {
    return {
      wrapStyle: "height:100%;",
      holdStyle: ("height:100%;min-height:" + (height.value) + (height.unit) + ";"),
    };
  },
};

/* src/widgetic/UI/Embed.html generated by Svelte v1.64.1 */
var diff = function(a, b) {
  var ids = b.map(function (i) { return i.id; });
  return a.filter(function (i) { return !ids.includes(i.id); });
};

var intrsct = function(a, b) {
  var ids = b.map(function (i) { return i.id; });
  return a.filter(function (i) { return ids.includes(i.id); });
};

function widthUnit(width) {
	return String(width).replace(parseInt(width), '') || 'px';
}

function heightUnit(height) {
	return String(height).replace(parseInt(height), '') || 'px';
}

function widthConfig(width, widthUnit) {
	return {
  value: parseInt(width),
  unit: widthUnit,
};
}

function heightConfig(height, heightUnit) {
	return {
  value: parseInt(height),
  unit: heightUnit,
};
}

function actualAutoscale(autoscale, resize) {
	return autoscale;
}

function inlineStyle(inline) {
	return inline ? 'display:inline-block;vertical-align:middle;' : '';
}

function styles_1(resize, widthConfig, heightConfig, align) {
	return styles[resize](widthConfig, heightConfig, align);
}

function wrapStyle(inlineStyle, styles$$1) {
	return 'position:relative;width:100%;overflow:hidden;' +
  inlineStyle +
  styles$$1.wrapStyle;
}

function holdStyle(styles$$1) {
	return 'position:relative; padding: 0;' + styles$$1.holdStyle;
}

function config$11(id, compositionid, widget, widget_id, widgetid, ref, wref, theme, content, autoscale, adaptive, branding) {
  // console.log("Embed config:", theme, content);
  
  // set embed options
  var config = {
    autoscale: autoscale,
    adaptive: adaptive,
    branding: branding
  };

  // set theme
  config.skin = theme;

  // set content
  if(content.length > 0) { config.content =  content; }

  // set demo
  else { content.demo = true; }

  // set ref
  if (ref || wref) { config.ref = ref || wref; }

  // set composition id
  if (id || compositionid) { config.composition = id || compositionid; }

  // set widget id
  else { config.widget_id = widget || widget_id || widgetid; }
  
  // console.log("Embed config:", config);
  return config;
}

function self$1(id, ref, wref) {
	return ref || wref || id || guid$1();
}

function data() {
  return {
    resize: 'fill-width',
    theme: {},
    content: [],
    width: 500,
    height: 300,
  };
}

var methods$1 = {
  _createEmbed: function _createEmbed(config) {
    var this$1 = this;

    if (this.composition) { this.composition.close(); }

    // this.set({ wrapHeight: 'auto' }); // reset autoscale height

    // console.log("SDK Declarative Embed Controller:", config);
    this.composition = Widgetic.UI.composition(this.refs.holder, config);
    // console.log("SDK Declarative Embed Controller:", this.composition);

    this.composition.on('reload', function (_) {
      this$1.composition.changeSkin(this$1.get('theme'));
      this$1.get('content').map(function (i) { return this$1.composition.addContent(i); });
    });

    this.api = this.composition.api;
    this.subscribe = this.composition.on.bind(this.composition);

    this.composition._iframe.setAttribute(
      'style',
      'position:absolute;top:0;left:0;width:0;height:0;max-width:100%;min-height:100%;min-width:100%'
    );
  },
};

function oncreate() {
  var this$1 = this;

  // console.log("SDK Declarative Embed Controller:");
  add$1(this.get('self'), this);

  this.observe('config', this._createEmbed);

  // persist the height of the wrapper so that the autoscale height is kept when wrapStyle is updated
  // this.observe(
  //   'actualAutoscale',
  //   () => (this.refs.wrap.style.height = 'auto')
  // );
  this.observe('wrapStyle', function () { return this$1.set({ wrapHeight: this$1.refs.wrap.style.height }); }
  );

  this.observe('theme', function (theme) { return this$1.composition.changeSkin(theme); });
  this.observe('content', function (content, prev) {
    if (!prev) { return; }

    var add = diff(content, prev);
    var removed = diff(prev, content);
    var updated = intrsct(content, prev);

    add.map(function (item) { return this$1.composition.addContent(item); });
    removed.map(function (item) { return this$1.composition.removeContent(item); });
    updated.map(function (item) { return this$1.composition.changeContent(item); });
  });
}

function ondestroy() {
  if (this.composition) { this.composition.close(); }
  remove(this.get('self'));
}

function create_main_fragment(component, state) {
	var div, div_1, div_style_value;

	return {
		c: function create() {
			div = createElement("div");
			div_1 = createElement("div");
			this.h();
		},

		h: function hydrate() {
			div_1.className = "wdgtc-holder";
			div_1.style.cssText = state.holdStyle;
			div.className = "wdgtc-wrap";
			div.style.cssText = div_style_value = "" + state.wrapStyle + "height:" + state.wrapHeight;
		},

		m: function mount(target, anchor) {
			insertNode(div, target, anchor);
			appendNode(div_1, div);
			component.refs.holder = div_1;
			component.refs.wrap = div;
		},

		p: function update(changed, state) {
			if (changed.holdStyle) {
				div_1.style.cssText = state.holdStyle;
			}

			if ((changed.wrapStyle || changed.wrapHeight) && div_style_value !== (div_style_value = "" + state.wrapStyle + "height:" + state.wrapHeight)) {
				div.style.cssText = div_style_value;
			}
		},

		u: function unmount() {
			detachNode(div);
		},

		d: function destroy$$1() {
			if (component.refs.holder === div_1) { component.refs.holder = null; }
			if (component.refs.wrap === div) { component.refs.wrap = null; }
		}
	};
}

function Embed(options) {
	init(this, options);
	this.refs = {};
	this._state = assign(data(), options.data);
	this._recompute({ width: 1, height: 1, widthUnit: 1, heightUnit: 1, autoscale: 1, resize: 1, inline: 1, widthConfig: 1, heightConfig: 1, align: 1, inlineStyle: 1, styles: 1, id: 1, compositionid: 1, widget: 1, widget_id: 1, widgetid: 1, ref: 1, wref: 1, theme: 1, content: 1, adaptive: 1, branding: 1 }, this._state);

	this._handlers.destroy = [ondestroy];

	var self = this;
	var _oncreate = function() {
		var changed = { width: 1, height: 1, widthUnit: 1, heightUnit: 1, autoscale: 1, resize: 1, inline: 1, widthConfig: 1, heightConfig: 1, align: 1, inlineStyle: 1, styles: 1, id: 1, compositionid: 1, widget: 1, widget_id: 1, widgetid: 1, ref: 1, wref: 1, theme: 1, content: 1, adaptive: 1, branding: 1, wrapStyle: 1, wrapHeight: 1, holdStyle: 1 };
		oncreate.call(self);
		self.fire("update", { changed: changed, current: self._state });
	};

	if (!options.root) {
		this._oncreate = [];
	}

	this._fragment = create_main_fragment(this, this._state);

	this.root._oncreate.push(_oncreate);

	if (options.target) {
		this._fragment.c();
		this._mount(options.target, options.anchor);

		callAll(this._oncreate);
	}
}

assign(Embed.prototype, proto);
assign(Embed.prototype, methods$1);

Embed.prototype._recompute = function _recompute(changed, state) {
	if (changed.width) {
		if (this._differs(state.widthUnit, (state.widthUnit = widthUnit(state.width)))) { changed.widthUnit = true; }
	}

	if (changed.height) {
		if (this._differs(state.heightUnit, (state.heightUnit = heightUnit(state.height)))) { changed.heightUnit = true; }
	}

	if (changed.width || changed.widthUnit) {
		if (this._differs(state.widthConfig, (state.widthConfig = widthConfig(state.width, state.widthUnit)))) { changed.widthConfig = true; }
	}

	if (changed.height || changed.heightUnit) {
		if (this._differs(state.heightConfig, (state.heightConfig = heightConfig(state.height, state.heightUnit)))) { changed.heightConfig = true; }
	}

	if (changed.autoscale || changed.resize) {
		if (this._differs(state.actualAutoscale, (state.actualAutoscale = actualAutoscale(state.autoscale, state.resize)))) { changed.actualAutoscale = true; }
	}

	if (changed.inline) {
		if (this._differs(state.inlineStyle, (state.inlineStyle = inlineStyle(state.inline)))) { changed.inlineStyle = true; }
	}

	if (changed.resize || changed.widthConfig || changed.heightConfig || changed.align) {
		if (this._differs(state.styles, (state.styles = styles_1(state.resize, state.widthConfig, state.heightConfig, state.align)))) { changed.styles = true; }
	}

	if (changed.inlineStyle || changed.styles) {
		if (this._differs(state.wrapStyle, (state.wrapStyle = wrapStyle(state.inlineStyle, state.styles)))) { changed.wrapStyle = true; }
	}

	if (changed.styles) {
		if (this._differs(state.holdStyle, (state.holdStyle = holdStyle(state.styles)))) { changed.holdStyle = true; }
	}

	if (changed.id || changed.compositionid || changed.widget || changed.widget_id || changed.widgetid || changed.ref || changed.wref || changed.theme || changed.content || changed.autoscale || changed.adaptive || changed.branding) {
		if (this._differs(state.config, (state.config = config$11(state.id, state.compositionid, state.widget, state.widget_id, state.widgetid, state.ref, state.wref, state.theme, state.content, state.autoscale, state.adaptive, state.branding)))) { changed.config = true; }
	}

	if (changed.id || changed.ref || changed.wref) {
		if (this._differs(state.self, (state.self = self$1(state.id, state.ref, state.wref)))) { changed.self = true; }
	}
};


var Embed$2 = Object.freeze({
	default: Embed
});

var embdAtts = [
  "compositionid",
  "id",
  "ref",
  "wref",
  "widget_id",
  "widgetid",
  "widget",
  "theme",
  "inline",
  "autoscale",
  "resize",
  "width",
  "height",
  "adaptive",
  "align",
  "branding" ];

function attributesToObject(attributes) {
  return Array.prototype.slice.call(attributes).reduce(function (acc, attribute) {
    acc[attribute.name] = attribute.value;
    return acc;
  }, {});
}

function getWidgetTags(document) {
  return Array.prototype.slice
    .call(document.querySelectorAll("*"))
    .filter(function (el) { return el.tagName.indexOf("WIDGETIC-") === 0 || el.tagName === "WIDGETIC" || 
                    Object.values(el.attributes).map(function (el) { return el.nodeName; }).includes('widgetic'); })
    .filter(function (el) { return el.__wdgtcparsed != true; });
}

function extractConfig(el) {
  var embedOptions = embdAtts
    .map(function (a) {
      var obj;

      var value = el.getAttribute(a);
      if (value === null) { return undefined; }
      return ( obj = {}, obj[a] = value, obj);
    })
    .filter(function (i) { return i !== undefined; })
    .reduce(function (i, acc) { return Object.assign(i, acc); });
  return {
    target: el,
    data: Object.assign(embedOptions, {
      theme: extractTheme(el),
      content: extractContent(el),
    }),
  };
}

function extractTheme(el) {
  // return el.dataset;
  var attrs = attributesToObject(el.attributes);
  var theme = {};
  for (var attr in attrs) {
    if (embdAtts.includes(attr)) { continue; }
    theme[camelcase(attr.replace("data-", ""))] = attrs[attr];
  }

  if (attrs["theme"]) { theme.id = attrs["theme"]; }

  return theme;
}

function extractContent(el) {
  return Array.prototype.slice
    .call(el.children)
    .map(function (child) { return ({
      attrs: attributesToObject(child.attributes),
      content: child.innerHTML,
    }); })
    .map(function (ref, i) {
      var attrs = ref.attrs;
      var content = ref.content;

      var item = {
        id: i + 1,
        order: i + 1,
        metadata: { service: "declarative" },
      };

      for (var attr in attrs) {
        item.metadata[camelcase(attr.replace("data-", ""))] = attrs[attr];
      }

      if (content) { item.metadata.content = content.trim(); }
      return item;
    });
}

function createEmbed(config) {
  config.target.__wdgtcparsed = true;
  config.target.innerHTML = "";
  new Embed(config);
}

var extractDeclarativeEmbeds = function (doc) {
  if ( doc === void 0 ) doc = document;

  return getWidgetTags(doc).map(extractConfig);
};

var parseDeclarativeEmbeds$1 = function () {
  extractDeclarativeEmbeds().map(createEmbed);
};


var declarative = Object.freeze({
	extractDeclarativeEmbeds: extractDeclarativeEmbeds,
	parseDeclarativeEmbeds: parseDeclarativeEmbeds$1
});

var defaultResizeStyle;
var embed;
var getHolder;
var parse$4;
var parseDeclarativeEmbeds;
var parseShortcodes;
var pubsub$5;
var replaceParentWithChild;
var resizeHolderTemplate;
var stylesFactory;
var whenReady$1;

parseDeclarativeEmbeds = declarative.parseDeclarativeEmbeds;

whenReady$1 = ready_1;

pubsub$5 = pubsub$1;

defaultResizeStyle = 'allow-scale-down';

replaceParentWithChild = function(parent) {
  var child, frag, grandparent;
  child = parent.children[0];
  grandparent = parent.parentNode;
  parent.removeChild(child);
  frag = document.createDocumentFragment();
  frag.insertBefore(child, null);
  grandparent.insertBefore(frag, parent);
  grandparent.removeChild(parent);
  return child;
};

getHolder = function(wrapper) {
  return wrapper.children[0];
};

resizeHolderTemplate = function(id, inline, styles, forIframeEmbed) {
  var inlineStyle;
  inlineStyle = inline ? 'display:inline-block;vertical-align:middle;' : '';
  if (forIframeEmbed) {
    return ("<div style=\"width:100%;" + inlineStyle + (styles.wrapStyle || '') + "\">") + ("<div style=\"position:relative; padding: 0;" + (styles.holdStyle || '') + "\">") + "$$$" + "</div>" + "</div>";
  } else {
    return "<div class=\"wdgtc-wrap\" data-wdgtc-id=\"" + id + "\" style=\"width:100%;" + inlineStyle + (styles.wrapStyle || '') + "\"> <div class=\"wdgtc-holder\" style=\"position:relative; padding: 0;" + (styles.holdStyle || '') + "\"> </div> </div>";
  }
};

stylesFactory = {
  'fixed': function(width, height) {
    var ratio;
    ratio = height * 100 / width;
    return {
      wrapStyle: "max-width: " + width + "px; min-width: " + width + "px;",
      holdStyle: "padding-top: " + ratio + "%;"
    };
  },
  'allow-scale-down': function(width, height) {
    var ratio;
    ratio = height * 100 / width;
    return {
      wrapStyle: "max-width: " + width + "px;",
      holdStyle: "padding-top: " + ratio + "%;"
    };
  },
  'fixed-height': function(width, height) {
    return {
      holdStyle: "height: " + height + "px; padding-top: 0;"
    };
  },
  'fill-width': function(width, height) {
    var ratio;
    ratio = height * 100 / width;
    return {
      holdStyle: "padding-top: " + ratio + "%;"
    };
  },
  'fill': function(width, height) {
    return {
      wrapStyle: "height: 100%",
      holdStyle: "height: 100%;min-height:" + height + "px"
    };
  }
};


/*
 Matches [widgetic-some-widget id=12345 width=200 height=100 inline] shortcodes
 and converts them to embed syntax
 */

parseShortcodes = function() {
  var children, el, extraWhitespace, i, len, newEl, newValue, parentEl, ref, ref1, results, shortcode, toAnchorTag, value;
  shortcode = /\[widgetic\-([-\w]+) *((?: [-\w]+(?:=.*?)?)+)\]/ig;
  extraWhitespace = /\s+/g;
  toAnchorTag = function(_, widget, attributes) {
    var htmlAttributes;
    htmlAttributes = attributes.trim().replace(extraWhitespace, ' ').split(' ').map(function(pair) {
      return 'data-' + pair;
    }).join(' ');
    return '<a href="https://widgetic.com/widget/' + widget + '/" class="widgetic-composition" ' + htmlAttributes + '></a>';
  };
  ref = document.querySelectorAll("body, body *");
  results = [];
  for (i = 0, len = ref.length; i < len; i++) {
    parentEl = ref[i];
    if ((ref1 = parentEl.nodeName) === 'HEAD' || ref1 === 'META' || ref1 === 'LINK' || ref1 === 'SCRIPT' || ref1 === 'TITLE') {
      continue;
    }
    children = parentEl.childNodes;
    results.push((function() {
      var j, len1, results1;
      results1 = [];
      for (j = 0, len1 = children.length; j < len1; j++) {
        el = children[j];
        if (el.nodeType !== 3) {
          continue;
        }
        value = el.nodeValue;
        newValue = value.replace(shortcode, toAnchorTag);
        if (value !== newValue) {
          newEl = document.createElement('div');
          newEl.innerHTML = newValue;
          results1.push(parentEl.replaceChild(newEl, el));
        } else {
          results1.push(void 0);
        }
      }
      return results1;
    })());
  }
  return results;
};

parse$4 = function() {
  return whenReady$1(function() {
    var compositionEls, el, i, len;
    parseDeclarativeEmbeds();
    parseShortcodes();
    compositionEls = document.querySelectorAll('.widgetic-composition');
    for (i = 0, len = compositionEls.length; i < len; i++) {
      el = compositionEls[i];
      embed(el);
    }
    pubsub$5.publish('parse');
  });
};


/*
Generates the wrapping html for the embed iframe
 */

parse$4.wrapperHtml = function(options, forIframeEmbed) {
  var styles;
  if (forIframeEmbed == null) {
    forIframeEmbed = false;
  }
  styles = stylesFactory[options.resize](options.width, options.height);
  return resizeHolderTemplate(options.composition, options.inline, styles, forIframeEmbed);
};

parse$4.iframeStyle = 'position:absolute;top:0;left:0;width:0;height:0;max-width:100%;min-height:100%;min-width:100%';

embed = function(el) {
  var composition, holder, options;
  options = {
    composition: el.getAttribute('data-id') || el.getAttribute('data-compositionid'),
    width: el.getAttribute('data-width') || 300,
    height: el.getAttribute('data-height') || 200,
    resize: el.getAttribute('data-resize') || defaultResizeStyle,
    brand_pos: el.getAttribute('data-brand') || 'bottom-right',
    branding: el.hasAttribute('data-branding'),
    inline: el.hasAttribute('data-inline'),
    autoscale: el.getAttribute('data-autoscale') || 'on'
  };
  if (!options.composition) {
    return;
  }
  if (!stylesFactory[options.resize]) {
    options.resize = defaultResizeStyle;
  }
  el.insertAdjacentHTML('afterbegin', parse$4.wrapperHtml(options));
  el = replaceParentWithChild(el);
  holder = getHolder(el);
  composition = new Widgetic.UI.composition(holder, options.composition, options);
  composition._iframe.setAttribute('style', parse$4.iframeStyle);
  composition._iframe.style.visibility = 'hidden';
  return composition._iframe.onload = (function(_this) {
    return function() {
      return composition._iframe.style.visibility = 'visible';
    };
  })(this);
};

var parse_1$2 = parse$4;

var require$$5 = ( Embed$2 && Embed ) || Embed$2;

var Composition$2;
var Editor$2;
var composition$2;
var editor$2;
var parse$3;
var plugin;
var popup$2;

Composition$2 = composition;

Editor$2 = editor;

plugin = plugin$1;

popup$2 = popup$3;

parse$3 = parse_1$2;

composition$2 = function() {
  return (function(func, args, ctor) {
    ctor.prototype = func.prototype;
    var child = new ctor, result = func.apply(child, args);
    return Object(result) === result ? result : child;
  })(Composition$2, arguments, function(){});
};

editor$2 = function() {
  return (function(func, args, ctor) {
    ctor.prototype = func.prototype;
    var child = new ctor, result = func.apply(child, args);
    return Object(result) === result ? result : child;
  })(Editor$2, arguments, function(){});
};

var UI$1 = {
  Composition: Composition$2,
  Editor: Editor$2,
  composition: composition$2,
  editor: editor$2,
  parse: parse$3,
  popup: popup$2,
  plugin: plugin,
  Embed: require$$5
};

var events = {
  COMPOSITION_SAVED: 'save',
  SKIN_SAVED: 'skin-save'
};

var Composition;
var Editor;
var Root;
var UI;
var Widgetic$1;
var api;
var auth;
var aye;
var config;
var detect;
var event;
var hasProxy;
var initProxy;
var originRegex;
var proxyInitialized;
var receiver;
var receivers;
var whenReady;
var win;

config = config_1;

Root = root;

api = api_1;

auth = auth_1;

detect = detect_1;

event = event$2;

whenReady = ready_1;

Composition = composition;

Editor = editor;

UI = UI$1;

aye = ayepromise;

win = window;

hasProxy = false;

receivers = {
  'a': api.request,
  'e': api.response,
  'i': Root.connect,
  'o': auth.connect,
  'd': Composition.apiReady,
  'u': Composition.connect,
  'ce': Composition.event,
  'pr': Composition.publicApiCallReply,
  'w': Editor.connect,
  'ee': Editor.event,
  'p': UI.popup.receiver,
  'r': auth.retry,
  'v': UI.plugin.connect,
  've': UI.plugin.event,
  'su': Composition.updateSize,
  'startPlaying': Composition.pausePlayingEmbed,
  'widgetPublicMethodsAndEvents': Composition.publicMethodsAndEvents
};

originRegex = (config.lo.replace(/(http|https)\:/, '')) + "|" + (config.domain.replace(/(http|https)\:/, ''));

originRegex = originRegex.replace(/\./g, '\\.');

originRegex = new RegExp(originRegex);

window.widgeticReceiver = receiver = function(e) {
  var d, error, name;
  if (!originRegex.test(e.origin)) {
    return;
  }
  d = e.data;
  try {
    if (typeof d !== "string") {
      return;
    }
    d = JSON.parse(d);
  } catch (error1) {
    return;
  }
  try {
    return typeof receivers[name = d.t] === "function" ? receivers[name](d, e) : void 0;
  } catch (error1) {
    
  }
};

Widgetic$1 = function() {
  if (typeof win['WidgeticAsyncInit'] === "function") {
    win['WidgeticAsyncInit']();
  }
  event.on(win, 'message', receiver);
  detect(win.location.href);
  Root.style();
  return setTimeout(UI.parse);
};

proxyInitialized = aye.defer();

initProxy = function() {
  var create;
  if (!hasProxy) {
    create = (function(_this) {
      return function() {
        (_this.root = new Root()).createProxy().then(function() {
          return proxyInitialized.resolve();
        }).fail(function(e) {
          return proxyInitialized.reject(e);
        });
        return hasProxy = true;
      };
    })(this);
    if (document.getElementsByTagName('body')[0]) {
      create();
    } else {
      whenReady(create);
    }
  }
  return proxyInitialized.promise;
};

Widgetic$1.prototype.init = function(client_id, redirect_uri) {
  initProxy.call(this);
  if (!(client_id && redirect_uri)) {
    return this;
  }
  auth.setAuthOptions(client_id, redirect_uri);
  return this;
};

Widgetic$1.prototype.api = function() {
  var args;
  args = arguments;
  return initProxy.call(this).then(function() {
    return api.apply(this, args);
  });
};

Widgetic$1.prototype.auth = function() {
  return auth.apply(this, arguments);
};

Widgetic$1.prototype.auth.register = function() {
  return auth.register.apply(this, arguments);
};

Widgetic$1.prototype.auth.status = function() {
  return api.getStatus.apply(this, arguments);
};

Widgetic$1.prototype.auth.token = function() {
  return api.accessToken.apply(this, arguments);
};

Widgetic$1.prototype.auth.disconnect = function() {
  return api.disconnect.apply(this, arguments);
};

Widgetic$1.prototype.JSON = JSON;

Widgetic$1.prototype.Queue = api.queue;

Widgetic$1.prototype.Aye = ayepromise;

Widgetic$1.prototype.Event = event;

Widgetic$1.prototype.GUID = require$$1$3;

Widgetic$1.prototype.pubsub = pubsub$1;

Widgetic$1.prototype.UI = UI;

Widgetic$1.prototype.find = embeds$1.find;

Widgetic$1.prototype.EVENTS = events;

Widgetic$1.prototype.version = '1.7.10';

Widgetic$1.prototype.parse = detect.parse;

Widgetic$1.prototype.uxhr = uxhr$1;

Widgetic$1.prototype.debug = {
  timestamp: function() {
    return console.warn('Widgetic.debug.timestamp is deprecated.');
  }
};

var widgetic = Widgetic$1;

var src = createCommonjsModule(function (module) {
var SDK, Widgetic;

SDK = widgetic;

if (window.Widgetic) {
  module.exports = window.Widgetic;
} else {
  Widgetic = new SDK();
  module.exports = Widgetic;
  window.Blogvio = Widgetic;
}
});

return src;

}());
