import commonjs from 'rollup-plugin-commonjs';
import coffee from 'rollup-plugin-coffee-script';
import nodeResolve from 'rollup-plugin-node-resolve';
import alias from 'rollup-plugin-alias';
import replace from 'rollup-plugin-replace';
import svelte from 'rollup-plugin-svelte';
import buble from 'rollup-plugin-buble';

const pkg = require('./package.json');

export default {
  input: 'src/index.coffee',
  output: {
    file: 'lib/sdk.dev.js',
    format: 'iife',
    name: 'Widgetic',
  },
  plugins: [
    svelte(),
    coffee(),
    buble(),
    nodeResolve({
      jsnext: true,
      main: true,
    }),
    commonjs({
      extensions: ['.js', '.coffee'],
    }),
    alias({
      resolve: ['.js', '.coffee'],
      utils: __dirname + '/src/widgetic/utils',
    }),
    replace({
      VERSION: pkg.version,
    }),
  ],
};
