const alignStyles = {
  left: '',
  center: 'margin: 0 auto',
  right: 'margin: 0 0 0 auto',
};

export const styles = {
  fixed: (width, height, align) => {
    const ratio = height.value * 100 / width.value;
    return {
      wrapStyle: `${alignStyles[align]};max-width: ${width.value}${
        width.unit
      }; min-width: ${width.value}${width.unit};`,
      holdStyle: `height: ${height.value}${height.unit}; padding-top: 0;`,
    };
  },
  'allow-scale-down': (width, height, align) => {
    const ratio = height.value * 100 / width.value;
    return {
      wrapStyle: `${alignStyles[align]};max-width: ${width.value}${
        width.unit
      };`,
      holdStyle: `padding-top: ${ratio}%;`,
    };
  },
  'fixed-height': (width, height, align) => {
    return {
      wrapStyle: `${alignStyles[align]};`,
      holdStyle: `height: ${height.value}${height.unit}; padding-top: 0;`,
    };
  },
  'fill-width': (width, height, align) => {
    const ratio = height.value * 100 / width.value;
    return {
      wrapStyle: `${alignStyles[align]};`,
      holdStyle: `padding-top: ${ratio}%;`,
    };
  },
  fill: (width, height, align) => {
    return {
      wrapStyle: `height:100%;`,
      holdStyle: `height:100%;min-height:${height.value}${height.unit};`,
    };
  },
};
